//global variables
var mainWindow = diigoUtil.firefox.getMainWindow();
var D = mainWindow.diigo;
var DlgIC = D.DlgIC;
var gContext;
var heightOffset=0;
//html string templates
var templates = {
	comment_html: "\n        <li id=\"#{ID}\" class=\"_template _comment #{CLASS_EDITABLE} #{ONLINE_CLASS}\">\n\t\t\t<div>\n\t\t\t\t<a title=\"#{REALNAME}\" href=\"#{USER_URL}\" class=\"avatar link\"><img src=\"#{USER_AVATAR_URL}\" alt=\"#{REALNAME}\"/></a> \n\t\t\t</div>\n\t\t\t<div style=\"margin-left: 40px;margin-right:20px;\">\n\t\t\t\t<span class=\"name\"><a href=\"#{USER_URL}\" class=\"link\">#{REALNAME} </a>#{DATETIME}</span>\n\t\t\t\t<p class=\"labelList\">\n\t\t\t\t    #{LABELS_HTML}\n\t\t\t\t    \n\t\t\t\t</p>\n\t\t\t\t<p class=\"content\">#{CONTENT}</p>\n\t\t\t</div>\n\t\t</li>\n        ",
	ann_html: "  \n            <div id=\"#{ID}\" class=\"listBox #{EMPTY_CLASS} #{CLASS_EDITABLE} #{CLASS_CAN_ADD_COMMENTS} _annotation _template\">\n              <h3 class=\"highlight #{ANN_TYPE_CLASS}\" style=\"margin: 5px 5px 10px 5px;display:none !important;\">\n                <a title=\"Delete\" onclick=\"#{ON_CLICK_DEL}\" href=\"#\" class=\"btn16 btnDel\"><img title=\"Delete\" src=\"../skin/spacer.gif\" style=\"width:16px;height:16px\" alt=\"\" /></a>\n                <a onclick=\"#{ON_CLICK_ADD_IC}\" href=\"#\" class=\"btn16 btnAddComment\"><img src=\"../skin/spacer.gif\" style=\"width:16px;height:16px\" alt=\"\" /></a>\n                <a onclick=\"#{ON_CLICK_JUMP_TO}\" class=\"_jumpTo\" href=\"#\">#{CONTENT}</a>\n              </h3>\n              <ul class=\"listContent\">#{COMMENT_ITEMS}</ul>\n              <div class=\"emptyContent\" style=\"height:18px;margin:0\"></div>\n            </div>\n            ",
	editComment_html: "\n\t\t\t\n\t\t\t<li class=\"annComment _template\">\n\t\t\t<div>\n\t\t\t\t<a title=\"#{REALNAME}\" href=\"#{USER_URL}\" class=\"avatar link\" style=\"margin-top:0;\"><img src=\"#{USER_AVATAR_URL}\" alt=\"#{REALNAME}\"/></a> \n\t\t\t</div>\n\t\t\t<div style=\"margin-left: 40px;margin-right:20px;\">\n\t\t\t\t            \n\t\t\t\t            <div style=\"margin-top: 10px;\">\n\t\t\t\t              <textarea style=\"width: 98%; height: 48px;\"></textarea>\n\t\t\t\t            </div>\n\t\t\t\t            \n\t\t\t\t            <p style=\"text-align: right;\">\n\t\t\t\t\t    <input type=\"button\" class=\"_commentOK\" name=\"ok\" value=\"Post\" style=\"margin-top: 3px; font-weight: bold; width: 50px;\"/>\n\t\t\t                    </p>\n\t\t\t                    <div style=\"margin-top: -23px;\" class=\"privacy\">\n\t\t\t\t              <select style=\"width:150px;\" class=\"_optionPrivacy\">\n\t\t\t\t                <option>Public</option>\n\t\t\t\t                <option>Private</option>\n\t\t\t\t              </select>\n\t\t\t\t            </div>\n\t\t\t\t             \n\t\t\t\n\t\t\t</div>\n\t\t\t<div id='diigotb-canpost' class='helpTip'>\n\t\t\t\tJunky public notes may be deleted, and your privilege to post public notes may be suspended.\n\t\t\t</div>\n\t\t\t<div id='diigotb-canotpost' class='helpTip'>\n\t\t\t\tTo reduce spam, posting public notes is a privilege reserved for active and trusted users. \n\t\t\t</div>\n\t\t\t</li>\n\t        "
};
$(onLoad);
function onLoad() {
	D.utils.dump('[IC] onload');
	
	//remove all template nodes to avoid exposing them to users
	$('._template').remove();
	
//	initSections();
	AnnTab.init();
	
	catchTheLinks();
	
	//draggable
	$('body>div.FNWrap>div.diigoFNTDiv:first-child')
	.bind('mousedown', function(event) {
		//NOTICE: Do not preventDefault() here, 
		//or the top document won't trigger mosuemove when the cursor is outside of the dlg
		//I guess this has sth to do with dragover
		DlgIC.startDrag(event);
	})
	
	//close button
	.find('a.menu').click(function() {DlgIC.hide(); return false;});
	$('body>div.FNWrap>.diigoFootDiv>.diigoResize')
	.bind('mousedown', function(event) {
		//NOTICE: Do not preventDefault() here, 
		//or the top document won't trigger mosuemove when the cursor is outside of the dlg
		//I guess this has sth to do with dragover
		DlgIC.startResize(event);
	});
	
	$('.diigoFNTDiv').find('a.public-hide')
	.bind('click', function(event) {
		D.handle('hideNotes', event);
		event.preventDefault();
	}).hide();
	
	var icon=$('.editIcon')
	.bind('mouseover', function(event) {
		try{
			D.AnnotationContextMenu.p=null;
			var offset=DlgIC.getDlgPos();
			event.screenX=offset.left;
			event.screenY=offset.top+$(window).height();
			event.item=this;
			D.AnnotationContextMenu.scheduleShow(event, DlgIC.ann);				
		}catch(e){throw(e);}
	});
	
	$(window).resize(function(event) {
		try{
		h=$('body>div.FNWrap>div.heightPillar');
		
		if(heightOffset==0)
			heightOffset=$(window).height()-h.height();
		ih=$(window).height() - heightOffset;
		//ih=ih<220?220:ih;
		h.height(ih-$('.diigoFootDiv').height()-1);
		}catch(e){
			//alert(e);
		}
	});
}
/**
 * Click a.link to open a.href in gBrowser instead of navigating the sidebar
 */
function catchTheLinks() {
	window.addEventListener('click', function(event) {
		var t = $(event.target);
		//if (t.is('a.public-hide')){return;}
		
		//catch a.link
		if (t.is('a.link') || (t = t.parents('a.link')).length > 0) {
			openUrl(t[0].href);
			event.preventDefault();
		}
	}, true); //use capture to allow opening <a> that stops event propagation. e.g. group name in group section title
}
/**
 * The collapsable sections
 */
//function initSections() {
//	$('div.section>h2').click(function() {
//		var j = $(this);
//		var collapsed = j.toggleClass('collapsed').is('.collapsed');
//		
//		if (collapsed) {
//			j.next('div').slideUp();
//		} else {
//			j.next('div').slideDown();
//		}
//		return false;
//	});
//}
/**
 * Call me when current url changes
 */
function changeUrl() {
	populateAnnotations_async();
}
/**
 * Asynchronous wrapper to avoid tab switching lag
 */
function populateAnnotations_async(force) {
	setTimeout(function() {populateAnnotations(force);}, 1);	
}
function populateAnnotations(force) {
	//D.utils.dump('populateAnntations doing...');
	AnnTab.populateAnnotations();
}
var tempediting=false;
/*================ Annotation ==================*/
var AnnTab = {
	filterMode: '_all', /*_all*/
//	jPcSec: null, /*page comment section*/
	jAnnSec: null,
	
	x:0,
	y:0,
	/**
	 * jquery .html() calls .empty() which unbinds events
	 * Make sure you dettach editor before .empty() is called upon a parent
	 */
	editor: (function() {
		return {
			jEdit: null,
			info: null, //what are we edition? see parameter of show()
			
			init: function() {
				var z = this;
				z.jEdit=null;
				
				var html=diigoUtil.string.showTpl(templates.editComment_html, {
					REALNAME: D.env.myProfile.realName,
					USER_URL: D.urls.getUserHomepageURL(D.env.user),
					USER_AVATAR_URL: D.urls.getUserAvatarURL(D.env.user)
				});
				z.jEdit = $(html).remove();
				z.jEdit.find('input[name="ok"]').click(function() {
					z.submit();
				})
				.end().find('textarea').keypress(function(event) {
					if (event.keyCode == 13 && event.ctrlKey) // Ctrl + Enter
						z.submit();
				/*}).scroll(function(event){
					var v=event.target.value.trim();
					if(event.target&&v!=''){
						$(event.target).css({height:'80px'});
					}*/
				}).keyup(function(event){
					var v=z.jEdit.find('textarea').val();
					DlgIC.editing=v.length>0?true:false;
				}).end().find('select').change(function(){
					tempediting=DlgIC.editing;
					DlgIC.editing=true;
					setTimeout(function(){
						DlgIC.editing=tempediting;
					},1000);
				});
			},
			
			submit: function() {
				try{
				var z = this;
				
				//do nothing if the content is empty
				var content = z.jEdit.find('textarea').val();
				if (!content) {
					D.notifyError(D.strings.getString('comment.input.content'));
					return;
				}
				
				//determine privacy mode
				var t = z.jEdit.find('select').val(), mode, groupName;
				if (t == '_private') {
					mode = 2;
				} else if (t == '_public') {
					mode = 0;
				} else {
					groupName = t;
				}
				
				if (z.info.what == 'pc') {
					//adding a page comment
					var data = {
						urlId: gContext.bookmark.urlId,
						mode: mode,
						content: content
					};
					
					if (groupName) {
						data.justForGroups = true;
						data.groups = [groupName];
					}
					D.WebAPI.addPageComment(data, gContext);
				} else {
					//adding an inline comment
					var data = {
						annotationId: z.info.annId,
						mode: mode,
						content: content
					};
					
					if (groupName) {
						data.justForGroups = true;
						data.groups = [groupName];
					}
					
					//avoiding "empty bubble"
					var ann = D.Annotation.find(gContext, data.annotationId);
					
					if (ann.type == D.ANNOTATION_TYPE_FLOATNOTE && !ann.saved) {
						ann._toAddInlineComment = data;
						ann.saving = true;
						D.WebAPI.addAnnotation(ann, gContext,function(data,ct,code){
							z.remove();
							AnnTab.placeEditor();
						});
					} else {
						D.WebAPI.addInlineComment(data, gContext,function(){
							z.remove();
							AnnTab.placeEditor();
						});
					}
				}
				
				z.processing();
				}catch(e){
					//alert(e);
				}
				//setTimeout(function(){
				//AnnTab.placeEditor();
				//},500);
			},
			
			processing: function() {
				DlgIC.editing = false;
				
				this.jEdit.find('textarea').val("").attr({disabled:true});
				this.jEdit.find('select').attr({disabled:true});
				this.jEdit.find('input._commentOK').val("Processing").attr({disabled:true}).css({width:"100px"});
				
			},
			
			remove: function() {
				try{
				if(this.jEdit==null){
					this.init();
				}
				DlgIC.editing = false;
				
				this.jEdit.find('textarea').attr({disabled:false});
				this.jEdit.find('select').attr({disabled:false});
				this.jEdit.find('input._commentOK').val("Post").attr({disabled:false}).css({width:"50px"});
				
				if (!this.jEdit[0].parentNode) return;
				
				var listBox = this.jEdit.parents('div.listBox:first');
				//restore empty class
				listBox.toggleClass('emptyListBox', listBox.find('>ul>li._comment').length == 0);
			
				this.jEdit[0].parentNode.removeChild(this.jEdit[0]);
				}catch(e){}
				
			},
			
			/**
			 * show the edit comment UI
			 * @param {Object} info {what: 'pc'/'ic', annId: 'annotationId'}
			 */
			show: function(info) {
				//DlgIC.editing = true;
				if(this.jEdit==null){
					this.init();
				}
				
			  this.info = info = info || this.info;
			  
			  if (info.what == 'ic')
				  var ann = D.Annotation.find(gContext, info.annId);
				  
			  //find the .listBox
			  var listBox = info.what == 'pc' ? AnnTab.jPcSec.find('>div.listBox') : $('#' + AnnTab.eleId_ann(ann));
			  
				//TODO privacy selection
				var j = this.jEdit.find('select._optionPrivacy').empty();
				
				var filterMode = AnnTab.filterMode;
//				//option cadidates
//				//public
//				if ((filterMode == '_all' || filterMode == '_public') &&
//						//!D.isSelectedURL(gContext.bookmark.url) &&
//						//(ann ? D.publicAnnotationsAllowed(gContext.bookmark.url) : true) &&
//						(ann ? !ann.onlyInGroup && ann.getComments('_private').length == 0 : true) //no private ic						
//				) 
//				{
//					j.append('<option value="_public">Public</option>');
//				}
				
				//private
				if ((filterMode == '_all' || filterMode == '_private'|| filterMode == '_nonepublic') &&
						(ann ? (!ann.onlyInGroup && ann.getComments('_public').length == 0&&ann.user == D.env.user) : true)) 
				{
					j.append('<option value="_private">Private</option>');
				}
				
				//groups
				var jOptgroup = $('<optgroup label="Groups"></optgroup>').appendTo(j);
				D.env.myGroups.forEach(function(g) {
					if ((filterMode == '_all' || filterMode == g.name|| filterMode == '_nonepublic') &&
							(ann && (ann.user != D.env.user || ann.onlyInGroup) ? ann.inGroup(g.name) : true)) 
					{
						jOptgroup.append(diigoUtil.dom.buildOne('option', {value: g.name}, [g.displayName]));
					}
				});
				if (jOptgroup.find('option').length == 0) jOptgroup.remove();
				
				//select the default option
				if (filterMode == '_all' && ann && ann.isPrivate()) {
					j.val('_private');
				}
				
				z=this;
				j.change(function(event){
					try{
					if(event.target.value == "_public"&&!D.publicAnnotationsAllowed(gContext.bookmark.url)){
						z.jEdit.find('textarea')
						//.val("")
						.attr({disabled:true});
						z.jEdit.find('input._commentOK').attr({disabled:true});
						z.jEdit.find('#diigotb-canpost').hide();
						z.jEdit.find('#diigotb-canotpost').show();
					}else{
						z.jEdit.find('textarea')
						///.val("")
						.attr({disabled:false});
						z.jEdit.find('input._commentOK').attr({disabled:false});
						if(event.target.value == "_public"){
							z.jEdit.find('#diigotb-canpost').show();
							z.jEdit.find('#diigotb-canotpost').hide();
						}else{
							z.jEdit.find('#diigotb-canpost').hide();
							z.jEdit.find('#diigotb-canotpost').hide();
						}
					}
					}catch(e){
						//alert(e);
					}
				});								
				if (j.find('option').length == 0) {
					//alert('You are not allowed to add comment here.');
					return;
				}
				var container=listBox.removeClass('emptyListBox').find('>ul');
				//prependTo
				this.jEdit.appendTo(container);
				
				this.jEdit.find('textarea').val('');
				if(ann){
					var comments = ann.getComments(filterMode);
					if(comments.length<=0){
						this.jEdit.find('textarea').focus();
					}
				}
				
				if(j.val()=="_public"&&!D.publicAnnotationsAllowed(gContext.bookmark.url)){
					this.jEdit.find('textarea')
					.val("")
					.attr({disabled:true});
					this.jEdit.find('input._commentOK').attr({disabled:true});
					this.jEdit.find('#diigotb-canpost').hide();
					this.jEdit.find('#diigotb-canotpost').show();
				}else if(j.val()=="_public"){
					this.jEdit.find('#diigotb-canpost').show();
					this.jEdit.find('#diigotb-canotpost').hide();
				}else{
					this.jEdit.find('#diigotb-canpost').hide();
					this.jEdit.find('#diigotb-canotpost').hide();
				}
			}
		};
	})(),
	
	init: function() {
		var z = this;
		
//		this.jPcSec = $('#sec-pc');
		this.jAnnSec = $('#sec-ann');
		
		//this.editor.init();
		
		//view filter
//		$('#viewFilter').find('>a')
//			.click(function() {z.showFilterMenu();})
//		.end().find('>ul')
//			.bind('mouseleave', function() {
//				$(this).hide();
//			})
//			.click(function(event) {
//				var j = $(event.target);
//				if (j.is('li') && j.attr('val') != z.filterMode) {
//					z.switchFilterMode(j.attr('val'), true);
//				}
//				$(this).hide();
//			}).hide();
	},
	
//	switchFilterMode: function(filterMode, refresh) {
//		this.filterMode = filterMode;
//		var j = $('#viewFilter');
//		j.find('>a')[0].firstChild.nodeValue = j.find('ul li[val=' + filterMode + ']').text();
//		
//		if (refresh) {
//			this.prepareForNewUrl();
//			populatePageComments(true);
//			populateAnnotations(true);
//		}
//	},
//	
//	/**
//	 * Show the view filter drop-down menu
//	 * <li value="_all">All</li>
//	 * ...
//	 * <li class="_group" value="groupName">Group display name</li>
//	 */
//	showFilterMenu: function() {
//		var j = $('#viewFilter>ul');
//		j.find('li._group').remove();
//		D.env.myGroups.forEach(function(g) {
//			j.append(diigoUtil.dom.buildOne('li', {val: g.name, 'class': '_group'}, [g.displayName]));
//		});
//		j.show();
//	},
	
	/**
	 * Gets filtered ann/pc/ic according to current filter mode
	 */
	_getFilteredItems: function (items) {
	  var z = this;
	  return items.filter(function (item) {
	    return item.matchFilter(z.filterMode);
	  });
	},
	
	/**
	 * Get the LABELS_HTML for pc/ic
	 * <p class="labelList">#{LABELS_HTML}</p>
	 */
	_labelsHtml: function(c) {
		var commentType = c.annotationId ? 'ic' : 'pc';
	  var filter = this.filterMode, 
	  		html = '',
	  		delHtml = c.canDelete() ? '<a title="Delete" href="javascript:void(0)" class="btnComment btnDel" onclick="#{ONCLICK};"><img title="Delete" src="../skin/spacer.gif" style="width:10px;height:10px" alt="" /></a>' : '';
	  		
	  //public
	  if (c.isPublic() && 
			  (filter == '_all' || filter == '_public') &&
			  //!D.isSelectedURL(gContext.bookmark.url) &&
			  c.user == D.env.user) {
	  	html += '<label class="_public"><span>Public</span>DEL</label>'
	  		.replace('DEL', diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ")"}));  
	  }
	  
	  //private
	  if (c.isPrivate() && (filter == '_all' || filter == '_private' || filter == '_nonepublic')) {
	  	html += '<label class="_private"><span>Private</span>DEL</label>'
	  		.replace('DEL', diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ")"}));  
	  }
	  
	  //groups
	  c.groups.forEach(function (g) {
	    if (filter == g.name || filter == '_all' || filter == '_nonepublic') {
	      html += diigoUtil.string.showTpl('<label class="_#{GROUP_NAME}"><a href="#{GROUP_URL}" class="link">#{GROUP_DISPLAY_NAME}</a>#{DEL}</label>', {
	        GROUP_NAME: g.name,
	        GROUP_DISPLAY_NAME: g.displayName,
	        GROUP_URL: D.urls.getGroupURL(g.name),
	        DEL: diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ", '" + g.name + "')"})
	      });
	    }
	  });
	  
	  return html;
	},
	
	/**
	 * Get unique element id for model objects
	 */
	eleId_pc: function(c) {
		return '_pc_' + c.id;	
	},
	
	eleId_ic: function(c) {
		return '_ic_' + c.id;
	},
	
	/**
	 * _ann_#{h_id}
	 * or
	 * _ann_#{h_id}_g_#{groupName}
	 */
	eleId_ann: function(ann) {
		var id = '_ann_' + ann.id;
		return id;
	},
	
//	/**
//	 * @public
//	 * Shows the Add Comment UI in public section
//	 */
//	goAddPageComment: function() {
//		this.editor.show({what: 'pc'});
//	},
	
	
	/**
	 * When the url is changed, call this before AnnTab.populatePageComments/AnnTab.populateAnnotations
	 */
	prepareForNewUrl: function() {
		this.editor.remove();
	},
	
	//Batch UI update
//	populatePageComments: function() {
//		var z = this;
//		var comments = z._getFilteredItems(gContext.pageComments);
//		
//		//restore editor after populating (Toolbar button comment)
//		var editorContainer = z.editor.jEdit.parents('div.listBox.pc');
//		
//		//jquery .empty() unbinds events. keep editor away from it
//		z.editor.remove();
//		
//		//page comments
//		var list = z.jPcSec.find('div.listBox').toggleClass('emptyListBox', comments.length == 0);
//		var ul = list.find('ul.listContent').empty();
//		comments.forEach(function(c) {
//			z._domAddPageComment(c, ul[0]); 
//		});
//		
//		if (editorContainer.length > 0)
//			z.editor.show();
//	},
	
	populateAnnotations: function() {
		var z = this;
		
		//jquery .empty() unbinds events. keep editor away from it
		z.editor.remove();
		
		z.jAnnSec.find('>div.annBox').empty();
		
		var ann = DlgIC.ann;
		//D.utils.dump('[DlgIC] populating', ann);
		//$('#windowTitle').text(ann.type == D.ANNOTATION_TYPE_FLOATNOTE ? 'Sticky Notes' : 'Inline Comments');
	    z.addAnnotation(ann);
	  
		h=$('a.public-hide');
		if(DlgIC.ann.isPublic())
			h.show();
		else
			h.hide();
		
		var t=$('.personalText').html(D.AnnotationContextMenu.tipMsg(ann,true));
		var icon=$('.editIcon');
		if(ann.user == D.env.user){
			icon.show();
			$('.footText').css({'margin-left':'30px'});
		}else{
			icon.hide();
			$('.footText').css({'margin-left':'7px'});
		}
	},
	
	/**
	 * Shows the editor in the default position
	 * memnuitem Add inline comment ->
	 */
	placeEditor: function() {
		var ann = DlgIC.ann;
		this.editor.show({what: 'ic', annId: ann.id});
	},
	
//	/**
//	 * Incremental UI update
//	 */
//	addPageComment: function(c, groupName) {
//		var z = this;
//		if (!c.matchFilter(z.filterMode)) return;
//		
//		var li = document.getElementById(z.eleId_pc(c));
//		if (!li) {
//		  //create element
//			var list = z.jPcSec.find('div.listBox');
//			var ul = list.find('ul.listContent');
//			li = z._domAddPageComment(c, ul[0]);
//			list.removeClass('emptyListBox');
//		} else if (groupName) {
//		  //the element is already there, update labels to reflect group changes
//		  $(li).find('p.labelList').html(z._labelsHtml(c));
//		}
//	},
//	
//	//returns the li
//	_domAddPageComment: function(c, ul) {
//	  var z = this;
//	  
//	  var html = diigoUtil.string.showTpl(templates.comment_html, {
//			ID: z.eleId_pc(c),
//			CLASS_EDITABLE: c.canDelete() ? 'editable' : '',
//			ONLINE_CLASS: c.userOnline ? 'online' : '',
//			CLASS_IC_OR_PC: '_pc',
//			USER: c.user,
//			REALNAME: c.realName,
//			USER_URL: D.urls.getUserHomepageURL(c.user),
//			USER_AVATAR_URL: D.urls.getUserAvatarURL(c.user),
//			DATETIME: c.datetime,
//			LABELS_HTML: z._labelsHtml(c),
//			CONTENT: c.content
//		});
//		
//		return prependFrag(ul, html);
//	},
//	
//	/**
//	 * first remove labels
//	 * when no labels left, remove the element
//	 */
//	removePageComment: function(c, groupName) {
//		var j = $('#' + this.eleId_pc(c));
//		if (j.length == 0) return;
//		
//		var labelList = j.find('p.labelList label');
//		if (groupName) {
//		  //removing from a group
//		  labelList.remove('label._' + groupName);
//		} else {
//		  //removing from smasher
//		  labelList.remove('label._public').remove('label._private');
//		}
//		
//		if (j.find('p.labelList label').length == 0) {
//		  //no labels left, remove the element
//		  var ul = j.parent('ul');
//		  j.remove();
//		  ul.parent().toggleClass('emptyListBox', ul.find('>li._comment').length == 0);
//		}
//	},
	
	addInlineComment: function(c) {
		var z = this;
		if (!c.matchFilter(z.filterMode)) return null;
		
		var j = $('#' + z.eleId_ic(c));
		if (j.length == 0) {
			var ann = c.getAnnotation();
			var list = $('#' + z.eleId_ann(ann));
			var ul = list.find('ul.listContent');
			
			var html = diigoUtil.string.showTpl(templates.comment_html, {
				ID: z.eleId_ic(c),
				CLASS_EDITABLE: c.canDelete() ? 'editable' : '',
				ONLINE_CLASS: c.userOnline ? 'online' : '',
				CLASS_IC_OR_PC: '_ic',
				USER: c.user,
				REALNAME: c.realName,
				USER_URL: D.urls.getUserHomepageURL(c.user),
				USER_AVATAR_URL: D.urls.getUserAvatarURL(c.user),
				DATETIME: c.datetime,
				LABELS_HTML: z._labelsHtml(c),
				CONTENT: diigoUtil.content2Html(c.content)
			});
			
			var li = appendFrag(ul[0], html);
			list.removeClass('emptyListBox');
			return li;
		}
		return null;
	},
	
	removeInlineComment: function(c, groupName) {
		var z = this;
		
		var j = $('#' + this.eleId_ic(c));
		if (j.length == 0) return;
		
		var labelList = j.find('p.labelList label');
		if (groupName) {
		  //removing from a group
		  labelList.remove('label._' + groupName);
		} else {
		  //removing from smasher
		  labelList.remove('label._public').remove('label._private');
		}
		
		if (j.find('p.labelList label').length == 0) {
		  //no labels left, remove the element
		  var ul = j.parent('ul');
		  j.remove();
		  ul.parent()
		  .toggleClass('emptyListBox', ul.find('>li._comment').length == 0)
		  .toggleClass('editable', c.getAnnotation().canDelete(z.filterMode));
		}
		
	},
	
	addAnnotation: function(ann, groupName) {
		var z = this;
		if (!ann.matchFilter(z.filterMode)) return null;
		
		var j = $('#' + z.eleId_ann(ann));
		if (j.length == 0) {
			var annTypeClass = '';
			var content = '';
			var comments = ann.getComments(z.filterMode);
			
			if (ann.type == D.ANNOTATION_TYPE_TEXT) { 
				content = diigoUtil.string.stripTags(ann.content);
			} else if (ann.type == D.ANNOTATION_TYPE_IMAGE) { 
				annTypeClass = 'imgHighlight';
				content = '(image)';
			} else if (ann.type == D.ANNOTATION_TYPE_FLOATNOTE) { 
				annTypeClass = 'floatNote';
				content = '(floating sticky note)';
			}
				
			var html = diigoUtil.string.showTpl(templates.ann_html, {
				ID: z.eleId_ann(ann),
				ANN_TYPE_CLASS: annTypeClass,
				EMPTY_CLASS: comments.length > 0 ? '' : 'emptyListBox',
				CLASS_EDITABLE: ann.canDelete(z.filterMode) ? 'editable' : '',
				CLASS_CAN_ADD_COMMENTS: ann.canAddComments() ? '' : '',//canAddComments
				CONTENT: content,
				COMMENT_ITEMS: '',
				ON_CLICK_DEL: 'AnnTab.onclick_del_ann(event, \'' + ann.id + '\');',
				ON_CLICK_ADD_IC: 'AnnTab.onclick_add_ic(event, \'' + ann.id + '\');',
				ON_CLICK_JUMP_TO: 'AnnTab.onclick_ann_jumpTo(event, \'' + ann.id + '\');'
			});
			
			var ret = appendFrag(z.jAnnSec.find('div.annBox')[0], html);
			comments.forEach(function(c) {
				z.addInlineComment(c);
			});
			return ret;
		}
		return null;
		
	},
	
	//TODO
	removeAnnotation: function(ann, groupName) {
		var id = this.eleId_ann(ann);
		var j = $('#' + id);
		if (j.length > 0 && !ann.matchFilter(this.filterMode)){ 
			this.editor.jEdit=null;
			j.remove();
		}
		this.editor.remove();
		
		//close the dialog if there are no more annotations
		if ($('div.annBox ._annotation').length == 0) {
			DlgIC.scheduleHide();
		}
	},
	//context event listeners
//	onpc_del: function(c, groupName) {
//		//D.utils.dump('[sidebar window]: onpc_del', c);
//		this.removePageComment(c, groupName);
//	},
//	
//	onpc_add: function(c, groupName) {
//		this.addPageComment(c, groupName);
//	},
	
	onic_add: function(c, groupName) {
		this.addInlineComment(c, groupName);
	},
	
	onic_del: function(c, groupName) {
		this.removeInlineComment(c, groupName);
	},
	
	onann_add: function(ann, groupName) {
		this.addAnnotation(ann, groupName);
	},
	
	onann_changeMode: function(ann) {
		this.removeAnnotation(ann);
		this.addAnnotation(ann);
	},
	
	onann_del: function(ann, groupName) {
		this.removeAnnotation(ann, groupName);
	},
	
	//onclick handlers for some sidebar buttons
	onclick_add_pc: function(event) {
	  this.goAddPageComment(); 
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	//X
//	onclick_del_pc: function(event, id, groupName) {
//		D.PageComment.del(gContext, id, groupName);
//	  event.stopPropagation(); 
//	  event.preventDefault();
//	},
	
	onclick_add_ic: function(event, annId) {
	  this.editor.show({what: 'ic', annId: annId});
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	//X
	onclick_del_ic: function(event, id, groupName) {
		D.InlineComment.del(gContext, id, groupName);
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	onclick_del_ann: function(event, annId) {
		var z = this, filter = z.filterMode, from = [];
		var ann = D.Annotation.find(gContext, annId);
		
		if (filter == '_all') {
			if (!ann.onlyInGroup) from.push(null); //from smasher
			ann.groups.forEach(function(g) {from.push(g.name);});
		} else if (filter == '_public' || filter == '_private') {
			if (!ann.onlyInGroup) from.push(null);  //from smasher
		} else {
			from.push(filter); //filter is the group name
		}
		
		from.forEach(function(a) {D.Annotation.del(gContext, annId, a);});
		
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	onclick_ann_jumpTo: function(event, annId) {
//	  D.Annotation.find(gContext, annId).jumpHere(true, false);
	  event.stopPropagation(); 
	  event.preventDefault();
	}
	
};
/*========== utils ===========*/
//function appendItem(_parent, tpl, data, callback, thiz) {
//	var html = diigoUtil.string.showTpl(tpl, data);
//	var j = $(appendFrag(_parent, html));
//	
//	if (callback) callback.call(thiz, j);
//	return j;	
//}
/**
 * Appends a document fragment to an element and returns the last child.
 * The appended fragment is supposed to be a single element
 */
function appendFrag(contextElement, html) {
	return domManipFragment(contextElement, html, function(frag) {
		contextElement.appendChild(frag);
	});
}
function prependFrag(contextElement, html) {
	return domManipFragment(contextElement, html, function(frag) {
		contextElement.insertBefore( frag, contextElement.firstChild );
	});
}
function domManipFragment(contextElement, html, fn) {
	var r = document.createRange();
	r.selectNode(contextElement);
	var f = r.createContextualFragment(html);
	
	//frag.lastChild will become null after appendChild, so remember it here.
	var last = f.lastChild;
	
	//get the last element node
	while (last = last.previousSibling)
		if (last.nodeType == 1) break;
	
	fn(f);
	return last;
}
/**
 * Usage: new SelfEvidentTextBox();
 */
function SelfEvidentTextBox(ele, tip) {
	var j = $(ele);
	tip = tip || j.val();
	j.focus(function() {
		if (j.val() == tip) {
			j.removeClass('tip').val('');
		}
	});
	
	j.blur(function() {
		if (j.val() == '') {
			j.addClass('tip').val(tip);
		}
	});
};
function openUrl(url) {
	D.utils.firefox.openAndReuseOneTabPerURL(url);
}