(function() {
	var D = window.diigo;
	var Utils = D.utils;

	var Class;
	Class = Utils["Class"];
	var Annotation;
	D.registerRunLater(function () {
		Annotation = D["Annotation"];
	});
	
/////////////////////////////////////////////////////////////////////////////////
//var Clip = D.Clip = Class.create(Annotation, {
//	initialize: function($super, data) {
//		data = data || {};
//		$super(data);
//		
//		this.type = D.ANNOTATION_TYPE_CLIP;
//		var topContext = this.context.getTopLevelContext();
//		
//		var doc = this.context.doc;
//		
//		var defaultExtra = {};
//		
//		this.extra = Utils.extend(defaultExtra, this.extra || {});
//	},
//	
//	jumpHere: function() {}
//
//});
//
//Utils.extend(Clip, {
//	paint: function(context, ann) {},
//	
//	unpaint: function(context, ann) {},
//	
//	/**
//	 * Tells whether an element can be clipped
//	 * 
//	 * 1. must not be an descendant of a diigo node
//	 * 2. must not be an ancestor of a diigo node
//	 * 3. must not be a diigo node
//	 * 4. must not be in the tag black list
//	 * 5. not too small
//	 */
//	isClippable: function(node) {
//		return true;
//	}
//});


//var VideoClip = D.VideoClip = Class.create(D.Annotation, {
//	initialize: function($super, data) {
//		data = data || {};
//		$super(data);
//		
//		this.type = D.ANNOTATION_TYPE_VIDEO;
//		var topContext = this.context;
//		
//		var doc = this.context.doc;
//		
//		var defaultExtra = {};
//		
//		this.extra = Utils.extend(defaultExtra, this.extra || {});
//		
//		if (!this.saved) {
//			if (!this._embedNode) {
//				throw('Must specify _embedNode for VideoClip');
//			}
//			
//			this.content = D.utils.dom.getElementXML(this._embedNode);
//		}
//	},
//	
//	jumpHere: function() {}
//
//});
//
//Utils.extend(VideoClip, {
//	paint: function(context, ann) {},
//	
//	unpaint: function(context, ann) {},
//	
//});


var FlashClip = D.FlashClip = Class.create(D.Annotation, {
	initialize: function($super, data) {
		data = data || {};
		$super(data);
		
		//type may be flash or video
		//this.type = D.ANNOTATION_TYPE_FLASH;
		var topContext = this.context;
		
		var doc = this.context.doc;
		
		var defaultExtra = {};
		
		this.extra = Utils.extend(defaultExtra, this.extra || {});
		
		if (!this.content) {
			throw('Must specify content for FlashClip');
		}
		
		if (!this.saved) {
			if (!this._embedNode) {
				throw('Must specify _embedNode for FlashClip');
			}
			
			//this.content = D.utils.dom.getElementXML(this._embedNode);
		}
	},
	
	getSrc: function() {
		return (this.content.match(/<embed.*?\s+src=['"]?(.*?)['"]?[\s>]/im) || [])[1] || '';
	},
	
	jumpHere: function() {}

});

Utils.extend(FlashClip, {
	paint: function(context, ann) {},
	
	unpaint: function(context, ann) {},
	
});

/////////////////////////////////////////////////////////////////////////////////
})();