

var mainWindow = diigoUtil.firefox.getMostRecentWindow();
var D = mainWindow.diigo;

var preSelectIndex=-1;


function __OnSelect(){
	try{
	var listbox=document.getElementById("Listbox-pageurls");//event.target;
	
	var eRemove=document.getElementById("btn-remove");
	var eRemoveAll=document.getElementById("btn-remove-all");
	
	preSelectIndex=listbox.selectedIndex;
	if(preSelectIndex>=0){
		eRemove.disabled=false;
		eRemoveAll.disabled=false;
	}else{
		eRemove.disabled=true;
		eRemoveAll.disabled=true;
	}
	
	}catch(e)
	{
	//	alert(e);
	}
}


function __ImportDelete(){
	var eRemove=document.getElementById("btn-remove");
	if(eRemove.disabled)return;
	var eRemoveAll=document.getElementById("btn-remove-all");
	var listbox = document.getElementById("Listbox-pageurls");
	var pre=listbox.selectedIndex;
	
	listbox.removeItemAt(listbox.selectedIndex);
	
	var newList=[];
	$.each(listbox.childNodes,function(v){
		row=listbox.childNodes[v];
		if(row.localName!="listhead"&&row.localName!="listcols"){
			url=row.childNodes[0].getAttribute('label');
			newList.push(url);		
		}
	});
	D.env.myBlackList=newList;
	D.prefs.val(D.env.user+'.Blacklist',diigoUtil.json.toJSON(newList));
	
	preSelectIndex=-1;
	listbox.selectedIndex=listbox.childNodes.length-2>pre?pre:pre-1;
	if(listbox.selectedIndex<0){
		eRemove.disabled=true;
		eRemoveAll.disabled=true;
	}
}


function __OnPageLoad(){
	
	D.env.myBlackList=diigoUtil.json.parseJSON(D.prefs.val(D.env.user+'.Blacklist'));
	
	var listbox=document.getElementById("Listbox-pageurls");
	var eRemoveAll=document.getElementById("btn-remove-all");
	if(D.env.myBlackList.length>0){
		eRemoveAll.disabled=false;
		$.each(D.env.myBlackList, 
		function(v) {
			url=D.env.myBlackList[v];
			if($.trim(url).length<=0)return;
			var listcell1 = document.createElement('listcell');
		    listcell1.setAttribute('label', url);
		    
		    var listitem = document.createElement('listitem');
		    listitem.appendChild(listcell1);
		    
		    listbox.appendChild(listitem);
		});
	}else{
		eRemoveAll.disabled=true;
	}
	D.runtime._focusedContext = D.getCurrentContext();
	document.getElementById("txt-address").value=
		D.runtime._focusedContext.bookmark.url.toLowerCase();
	if(D.runtime._focusedContext.bookmark.url.length>0){
		document.getElementById("btn-add").disabled=false;
	}
}

function __Clear(){
	var listbox=document.getElementById("Listbox-pageurls");
	while(listbox.itemCount>0){
		listbox.removeItemAt(0);
	}
	D.env.myBlackList=[];
	D.prefs.val(D.env.user+'.Blacklist',"[]");
	
	document.getElementById("btn-remove-all").disabled=true;
}

function __OnTextChange(){
	var etxt=document.getElementById("txt-address");
	var ebtn=document.getElementById("btn-add");
	if(etxt.value.length>=0){
		ebtn.disabled=false;
	}else{
		ebtn.disabled=true;
	}
	
}

function add2Blacklist(){
	var ebtn=document.getElementById("btn-add");
	if(ebtn.disabled)return;
	var newUrl=document.getElementById("txt-address").value;
    
	try{
	if(D.isSelectedURL(newUrl)){
	    document.getElementById("txt-address").value="";
	    ebtn.disabled=true;
		return;
	}
	}catch(e){
		if(e.name == "NS_ERROR_MALFORMED_URI")
		{
			alert(D.strings.getString('selectpage.error'));
			return;
		}
	}
	D.env.myBlackList.push(newUrl);
	D.prefs.val(D.env.user+'.Blacklist',diigoUtil.json.toJSON(D.env.myBlackList));
	
	var listbox=document.getElementById("Listbox-pageurls");
	var listcell1 = document.createElement('listcell');
    listcell1.setAttribute('label', newUrl);
    var listitem = document.createElement('listitem');
    listitem.appendChild(listcell1);
    listbox.appendChild(listitem);
    
    document.getElementById("txt-address").value="";
    document.getElementById("btn-remove-all").disabled=false;
    ebtn.disabled=true;
    
}

function __oncancel(){
	
}

function __onaccept(){
	var listbox = document.getElementById("Listbox-pageurls");
	var newList=[];
	$.each(listbox.childNodes,function(v){
		row=listbox.childNodes[v];
		if(row.localName!="listhead"&&row.localName!="listcols"){
			url=row.childNodes[0].getAttribute('label');
			newList.push(url);		
		}
	});
	D.env.myBlackList=newList;
	D.prefs.val(D.env.user+'.Blacklist',diigoUtil.json.toJSON(newList));
	
	if(D.prefs.val(D.env.user+'.useBlacklist')){
		context=D.getCurrentContext();
		D.handle('toggleHighlight',false);				
		context.unpaintAllAnnotations();

		context.paintAllAnnotations();	
		
		D.Sidebar.refresh('annotations', context, true);
	}
}

