//global variables
var mainWindow = diigoUtil.firefox.getMainWindow();
var D = mainWindow.diigo;
var Sidebar = D.Sidebar;
//maintains Sidebar.pageWin
Sidebar.pageWin = window;
function onunload() {Sidebar.pageWin = null;}
var currentTab, currentSubTab;
//references diigo.Sidebar.currentContext
var gContext;
//other script can use sidebar.window.loaded to see whether sidebar window has been inited
var loaded = false;
var popupright;
//html string templates
var templates = {
	bookmark_html: "\n              <li class=\"_template\"><a class=\"link\" target=\"_blank\" href=\"#{URL}\"><img style=\"#{PRIVATE_STAR}margin-right:5px;\" src=\"chrome://diigotb/skin/lock-small.gif\"/>#{TITLE}</a> <span>#{DATETIME}</span></li>\n              ",
	comment_html: "\n                      <li id=\"#{ID}\" class=\"_template _comment #{CLASS_EDITABLE} #{ONLINE_CLASS}\"><a title=\"#{REALNAME}\" href=\"#{USER_URL}\" class=\"avatar link\"><img src=\"#{USER_AVATAR_URL}\" alt=\"#{REALNAME}\"/></a> <span class=\"name\"><a class=\"link\" href=\"#{USER_URL}\">#{REALNAME} </a>#{DATETIME}</span>\n                        <p class=\"labelList\">\n                          #{LABELS_HTML}\n                          \n                        </p>\n                        <p class=\"content\">#{CONTENT}</p>\n                      </li>\n                      ",
	ann_html: "  \n                    <div id=\"#{ID}\" class=\"listBox #{EMPTY_CLASS} #{CLASS_EDITABLE} #{CLASS_CAN_ADD_COMMENTS} _annotation _template\">\n                      <h3 class=\"highlight #{ANN_TYPE_CLASS}\">\n                        <a onclick=\"#{ON_CLICK_DEL}\" href=\"#\" class=\"btn16 btnDel\"><img src=\"../skin/spacer.gif\" style=\"width:16px;height:16px\" alt=\"\" /></a>\n                        <a onclick=\"#{ON_CLICK_ADD_IC}\" href=\"#\" class=\"btn16 btnAddComment\"><img src=\"../skin/spacer.gif\" style=\"width:16px;height:16px\" alt=\"\" /></a>\n                        <a onclick=\"#{ON_CLICK_JUMP_TO}\" class=\"_jumpTo\" href=\"#\">#{CONTENT}</a>\n                      </h3>\n                      <ul class=\"listContent\">#{COMMENT_ITEMS}</ul>\n                      <div class=\"emptyContent\" style=\"height:18px;margin:0\"></div>\n                    </div>\n                    ",
	reader_html: "\n                      <li class=\"#{ONLINE_CLASS} _template\"><a \n                          title=\"#{USERNAME}\" \n                          href=\"#{USER_URL}\" \n                          class=\"avatar link\"><img src=\"#{AVATAR_URL}\" alt=\"#{REALNAME}\"/>\n                        </a>\n                        <span class=\"name\"><a class=\"link\" href=\"#{USER_BOOKMARK_URL}\">#{REALNAME} </a>#{LOCATION}</span>\n                        <p class=\"readerInfo\">Recent bookmark: <span>#{RECENT_BOOKMARK_DATETIME}</span>\n                        <a class=\"link\" href=\"#{RECENT_BOOKMARK_URL}\">#{RECENT_BOOKMARK_TITLE}</a></p>\n                      </li>\n                      ",
	editComment_html: "\n                      <li class=\"annComment _template\">\n                        <fieldset>\n                          <legend>Add Comment</legend>\n                          <div><span style=\"color:#999; line-height:12px\"><!-- #{VISIBILITY} --></span></div>\n                          \n                          <div class=\"privacy\">\n                            <select class=\"_optionPrivacy\">\n                              <option>Public</option>\n                              <option>Private</option>\n                            </select>\n                          </div>\n                          <div style=\"margin-top: 5px\">\n                            <textarea spellcheck=\"true\" style=\"width:98%; height:80px\">content</textarea>\n                          </div>\n                          \n                          <p style=\"text-align:right\">\n                            <input class=\"_commentOK\" name=\"ok\" type=\"button\" value=\"OK\" style=\"font-weight:bold;width:50px\" />\n                            <input name=\"cancel\" type=\"button\" value=\"Cancel\" style=\"width:50px\" />\n                          </p>\n                        </fieldset>\n                      </li>\n                      ",
	friend_html: "\n                <li class=\"#{ONLINE_CLASS} _template\">\n                  <a title=\"#{REALNAME}\" href=\"#{USER_URL}\" class=\"avatar link\"><img src=\"#{AVATAR_URL}\" alt=\"#{REALNAME}\"/></a>\n                  <span class=\"name\"><a class=\"link\" href=\"#{USER_URL}\">#{REALNAME} </a><a href=\"#{SEND_MSG_URL}\" class=\"btn16 iconMsg\" title=\"Send Message\"><img src=\"../skin/spacer.gif\" style=\"width:16px;height:16px\" alt=\"\" title=\"Send message\" onclick=\"#{SEND_MESSAGE_ONCLICK}\"/></a></span>\n                  <p class=\"bookmark\"><a class=\"link\" href=\"#{RECENT_BOOKMARK_URL}\" title=\"latest public bookmark\">#{RECENT_BOOKMARK_TITLE}</a> <span>#{RECENT_BOOKMARK_DATETIME}</span></p>\n                  <p class=\"message\"><a class=\"link\" href=\"#{MSG_URL}\" title=\"latest public message\">#{MSG_SUBJECT}</a> <span>#{MSG_DATETIME}</span></p>\n                  <p class=\"messageLast\"><a class=\"link\" href=\"#{MSG_URL}\">#{MSG_BODY}</a></p>\n                </li>\n                "
};
//flags: whether a tab has been populated
var populated = {
	pageComments: false,
	annotations: false,
	readers: false,
	thisUrl: false
};
$(onLoad);
function onLoad() {
	var start_time = new Date();
	window.loaded = true;
	
	gContext = Sidebar.currentContext;
	//remove all template nodes to avoid exposing them to users
	$('._template').remove();
	
	initTabs();
	
	//window.oncontextmenu=contextMenu;
	
	$('input.selfEvident').each(function() {
		new SelfEvidentTextBox(this);
	});
	
	BookmarkTab.init();
	BookmarkTab.populateMyBookmarks();
	
	initSections();
	
	AnnTab.init();
	
	UrlLock.init();
	UrlLock.refresh();
	
	selectTab(D.prefs.val('sidebar.selectedTab') || 'bookmarks');
	populateMyLists();
	
	$(window).bind('resize', onResize);
	catchTheLinks();
	
	ChromeTooltip.run();
	
	changeUrl(true);
	var end_time = new Date();
	D.utils.dump('[Sidebar Page] loading took ', end_time - start_time);
	
	/*var subscriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
	                       .getService(Components.interfaces.mozIJSSubScriptLoader);
	subscriptLoader.loadSubScript('chrome://browser/content/nsContextMenu.js');
	
	popupright=document.createElement("menupopup");
	popupright.id='contextRightClick';
	popupright.setAttribute("onpopupshowing", 'if(event.target != this) return true; gContextMenu = new nsContextMenu(this, window.getBrowser()); return gContextMenu.shouldDisplay;');
	popupright.setAttribute("onpopuphiding", 'if (event.target == this) { gContextMenu = null; }');
	//for(n in popupright)
	/*popupright.appendChild(D.utils.dom.build2(
			'menuitem', {
				label: 'All Friends \u00bb',
				accesskey: 'A'}));*/
}
/**
 * Click a.link to open a.href in gBrowser instead of navigating the sidebar
 */
function catchTheLinks() {
	window.addEventListener('click', function(event) {
		//ignore right click
		if (event.button == 2) return;
		
		var t = $(event.target);
		
		//catch a.link
		if (t.is('a.link') || (t = t.parents('a.link')).length > 0) {
			openUrl(t[0].href);
			event.preventDefault();
			event.stopPropagation();
		}
	}, true); 
	//use capture to allow opening <a> that stops event propagation. e.g. group name in group section title
	//2007-11-18 06:36:58 UTC How about we stop event propagation right here?
}
/**
 * toggle class p.pageLocked to change the lock style
 */
var UrlLock = {
	p: null,
	//whether the user clicked to lock
	lockedByUser: false,
	
	init: function() {
		var p = this.p = $('#currentPageTitle+p.pageLink:first');
		var z = this;
		
		p.find('a.btnLock')
		.click(function() {
			Sidebar.lockUrl(!p.is('.pageLocked'));
			z.lockedByUser = Sidebar.urlLocked;
			return false;
		});
	},
	
	refresh: function() {
		this.p.toggleClass('pageLocked', Sidebar.urlLocked);
	},
	
	/**
	 * Automatically lock url while editing
	 */
	autoLock: function(lock) {
		if (lock == Sidebar.urlLocked) return;
		if (!lock && this.lockedByUser) return;
		Sidebar.lockUrl(lock);
	}
};
function populateMyLists() {
	var lists = D.env.myList, outliner=D.env.outliners;
	var sel = $('#bm-search-select-list');
	sel.empty().append(diigoUtil.dom.buildOne('option', {value: -1}, [new Array(20).join('-')]));
	
	outliner.forEach(function(item) {
		sel.append(diigoUtil.dom.buildOne('option', {
			value: item.id,
			uri: item.uri
		}, [item.title]));
	});
	
	sel.append(diigoUtil.dom.buildOne('option', {value: -1}, [new Array(20).join('-')]));
	
	lists.forEach(function(item) {
		sel.append(diigoUtil.dom.buildOne('option', {
			value: item.id,
			uri: item.uri
		}, [item.title]));
	});
	
	//sel.append(diigoUtil.dom.buildOne('option', {value: -2}, ['Create a list...']));
	//try to restore last selected list
	var lastSelectedListId = D.prefs.val('sidebar.selectedList');
	sel.val(lastSelectedListId || -1);
}
function initTabs() {
	//first level tabs
	$('#tabs-container1>li a').each(function(i) {
		$(this).click((function(i) {
			return function() {
				this.blur(); //get rid of the dotted outline
				selectTab(['bookmarks', 'thisUrl', 'friends'][i]);
				return false;
			};
		})(i));
	});
		
	
	//This URL sub tabs
	$('#tabs-container2>li').each(function(i) {
		$(this).click((function(i) {
			return function() {
				this.blur(); //get rid of the dotted outline
				selectTab(['readers', 'annotations'][i]);
				return false;
			};
		})(i));
	});
}
/**
 * Activates a tab and refresh UI
 * 
 * @param {String} which 'bookmarks' | 'thisUrl' | 'annotations' | 'readers' | 'friends'
 */
function selectTab(which, callback) {
	//first level tabs
	var firstLevelTabName = (which == 'annotations' || which == 'readers') ? 'thisUrl' : which;
		
	var i = {bookmarks: 0, thisUrl: 1, friends: 2}[firstLevelTabName];
	
	$('#tabs-container1>li')
		.not(':eq(' + i + ')').removeClass('current')
		.end().eq(i).addClass('current');
	
	$('#tabs-container1+div.tabContent>div')
		.not(':eq(' + i + ')').hide()
		.end().eq(i).show();
		
	//sub tabs
	//sub tab defaults to readers
	currentTab = (which == 'thisUrl') ? currentSubTab || 'annotations' : which;
	
	//remember the last selected tab
	D.prefs.val('sidebar.selectedTab', currentTab);
	
	if (currentTab == 'annotations' || currentTab == 'readers') {
		currentSubTab = currentTab;
		i = {readers: 0, annotations: 1}[currentSubTab];
		$('#tabs-container2>li')
			.not(':eq(' + i + ')').removeClass('current')
			.end().eq(i).addClass('current');
		$('#tabs-container2+div>div')
			.not(':eq(' + i + ')').hide()
			.end().eq(i).show();
		if (!pageNotSupported()) {
			//load necessary data
			D.WebAPI.loadBookmark({url: gContext.bookmark.url, what: 'pageComments bookmarkInfo readers'}, gContext);
			populateThisUrl();
			
			if (currentTab == 'readers') 
				populateReaders();
			else if (currentTab == 'annotations') { 
				populateAnnotations();
				populatePageComments();
			}
		}
	}
	
	//if (currentTab == 'friends') populateFriends();
	
	//if (currentTab == 'bookmarks') BookmarkTab.selectBookmarkFilter();
	
	adjustHeight();
	
	if (callback) callback();
}
function isTabAvailable(tab) {
	return tab == 'annotations' || tab == 'readers' ? (!!gContext) : true;
}
function EditTag(h) {
	//if(h>='a'&&h<='z'){
		D.utils.firefox.openTab(D.urls.getEditTagsURL()+"&q="+h); 
	//}else{
	//	D.utils.firefox.openTab(D.urls.getEditTagsURL()+"&alpha=others"); 
	//}
	//mainWindow.focus();
}
var BookmarkTab = {
	//currently selected bookmark filter tab
	currentFilterTab: '',
	filterTabs: ['tag', 'fullText'], //'list'
	
	init: function() {
		var z = this;
		
		//click X to clear text
		//the logic here is subtle. need to work well with SelfEvidentInput
		//SelfEvidentInput must be initialized before this
		$('#bm-search-input-tag,#bm-search-input-fullText').each(function() {
			var j = $(this);
			j.focus(function() {
				j.parent().addClass('x');
			})
			.blur(function() {
				if (j.hasClass('tip')) {
					j.parent().removeClass('x');
				}
			})
			.next('em').click(function() {
				//click on X
				//2008-7-11 7:57:14 UTC I used to check j.hasClass('tip') to avoid unecessary action. 
				//but if someone deletes all input by pressing back space and then click X, X has no effect.
//				if (j.hasClass('tip')) {
//					//jTagInput.trigger('focus')[0].focus();
//				} else {
					j.val('').trigger('blur')[0].blur();
					z.searchTag();
//				}
				
			});
		});
		
		//clear the last tag/search term when user clears the input
		$('#bm-search-input-tag').blur(function() {
			var j = $(this);
			if (j.hasClass('tip')) {
					D.prefs.set('sidebar.searchTag', '', true);
				}
		});
		
		$('#bm-search-input-fullText').blur(function() {
			var j = $(this);
			if (j.hasClass('tip')) {
					D.prefs.set('sidebar.searchTerm', '', true);
				}
		});
		
		z.setupTagAutoComplete();
		
		var jFilter = this.jFilter = $('#bm-search');
		
		//tab switching
		var j = jFilter;
		
		j.find('>legend:first a').each(function(i) {
			$(this).click((function(i) {
				return function() {
					this.blur(); //get rid of the dotted outline
					z.selectBookmarkFilter(z.filterTabs[i]);
					return false;
				};
			})(i));
		});
		
		j = j.find('>div');
		var byTag = j.eq(0);
		//var byList = j.eq(1);
		var byFullText = j.eq(2);
		
		byTag.find('input[type="button"]').click(function() {z.searchTag();});
		
		$('#bm-search-select-list').bind('change', function() {
			var listId = Number($(this).val());
			
			if (listId > 0) {
				//remember last selected list
				D.prefs.val('sidebar.selectedList', listId);	
			}
			z.searchByList();
		});
		
		byFullText.find('input[type="button"]').click(function() {z.searchFullText();});
		
		$('#diigo-unread').click(function(){
			z.searchTag();
		});
		
		$('#bm-search-input-fullText').keypress(function(event) {
			if (event.keyCode == 13/*return*/)
				z.searchFullText();
		});
		
		//see all my tags link
		$('#link-seeAllMyTags').attr({href: D.urls.getEditTagsURL()});
		//$('#link-createList').attr({href: D.urls.getCreateListURL()});
		$('#link-createList').mousedown(function(event){
			D.handle('OnCreateList', event,populateMyLists);
			event.preventDefault();
			event.stopPropagation();
			return false;
		});
		$('#link-advancedSearch').attr({href: D.urls.getFullTextSearchURL("", 'my', true)});
	
		//star in this url tab
		$('#currentPageTitle>a:first').click(function() {
			var bm = gContext.bookmark;
			if (!bm.saved) {
				$(this.parentNode).addClass('bookmarked');
			}
			
			D.handle('bookmark', true, gContext);
			
			return false;
		});
		
		this.selectBookmarkFilter('my');
		
		//restore last search tag/term
		var lastSearchTerm = D.prefs.get('sidebar.searchTerm', true);
		if (lastSearchTerm) {
			$('#bm-search-input-fullText').val(lastSearchTerm).removeClass('tip');
		}
		
		var lastSearchTag = decodeURIComponent(D.prefs.get('sidebar.searchTag', true));
		if (lastSearchTag) {
			$('#bm-search-input-tag').val(lastSearchTag).removeClass('tip');
			var lastunread = D.prefs.get('sidebar.unreadTag');
			if (lastunread == 'true') {
				$('#diigo-unread').attr({checked:true});
			}else{
				$('#diigo-unread').removeAttr("checked");
			}
			z.searchTag();
		}
	},
	
	auto:null,
	
	setupTagAutoComplete: function() {
		
		auto=null;
		var jTagInput = $('#bm-search-input-tag');
		//tag autosuggestion
		auto=new AutoComplete(jTagInput, {
			resultsClass: 'diigolet ac_results', 
			data: D.env.myTags, 
			mode: 'multiple', 
			multipleSeparator: ' ', 
			onStartSearch: this.searchTag,
			onClickEditTag: EditTag
		});
	},
	updateTagSearch: function(tag,unread) {
		$('#bm-search-input-tag').val(tag).removeClass('tip');
		if(unread){
			$('#diigo-unread').attr({checked:true});
		}else{
			$('#diigo-unread').removeAttr("checked");
		}
		this.selectBookmarkFilter(this.filterTabs[0]);
		
		this.searchTag();
	},	
	updateListSearch: function(listId) {
		$('#bm-search-select-list').val(listId);
		
		this.selectBookmarkFilter(this.filterTabs[1]);
		
		D.prefs.val('sidebar.selectedList', listId);	
		
		this.searchByList();
	},	
	/**
	 * Refresh search results, call this after saving bookmark so that the search resutls are up to date
	 */
	refreshBookmarkSearch: function() {
		var z = this;
		/*if (z.currentFilterTab == 'my' || z.currentFilterTab == 'tag')
			z.searchTag();
		else */if (z.currentFilterTab == 'list')
			z.searchByList();
//		else if (z.currentFilterTab == 'fullText')
//			z.searchFullText();
	},
	
	searchTag: function() {
		try{
		var z = BookmarkTab;
		
		D.utils.dump('[sidebar] searchTag');
		
		z.clearSearchResults('searching...');
		
		var j = $('#bm-search-input-tag'), v = diigoUtil.string.trim(j.val());
		if (v && v != j[0].tip) {
			var data = {
					tags: D.parseTags(v, true),
					bmcount: 20,
					unread:$('#diigo-unread').is(':checked')};
			D.WebAPI.searchBookmarkbyTag(data, function(r) {
				
				z.doPopulateBookmarks(
					r.bookmarks, 
					'Tags: ' + diigoUtil.string.showTpl('<a class="link" href="#{0}">#{1}</a>', [D.urls.getUserTagBookmarksURL(D.unparseTags(data.tags)), D.unparseTags(data.tags, ',')]), 
					null, 
					'See more on the web', 
					D.urls.getUserTagBookmarksURL(D.unparseTags(data.tags))
				);
			});
			
			z.currentFilterTab = 'tag';
			//remember last search tag
			D.prefs.set('sidebar.searchTag', encodeURIComponent(v), true);
			
		} else {
			//empty tags
			//z.selectBookmarkFilter('my');
			z.currentFilterTab = 'my';
			if(!$('#diigo-unread').is(':checked')){
				z.populateMyBookmarks(true);
			}else{
				z.populateMyUnreadBookmarks(true);
			}
			
		}
		D.prefs.set('sidebar.unreadTag', $('#diigo-unread').is(':checked'));
		}catch(e){throw(e);}
	},
		
	searchByList: function () {
		var z = this;
		var j = $('#bm-search-select-list');
		var listId = j.val();
		
		if (listId == -1) {
			z.clearSearchResults();
		} else {
			z.clearSearchResults('loading...');
			D.WebAPI.loadBookmarksInList(listId, 20, function(r) {
				var selectedOption = j[0].options[j[0].selectedIndex];
				z.doPopulateBookmarks(
					r.bookmarks, 
					'List: ' + diigoUtil.string.showTpl('<a class="link" href="#{0}">#{1}</a>', [D.urls.getListURL(selectedOption.getAttribute('uri')), selectedOption.text]) + diigoUtil.string.showTpl(' / <a class="link" href="#{0}">edit</a>', [D.urls.getEditListURL(selectedOption.getAttribute('uri'))]), 
					null, 'see all my lists', 
					D.urls.getMyListsURL()
				);
			});
		}
	},
	
	searchFullText: function() {
		var z = this;
		
		var j = $('#bm-search-input-fullText'), v = diigoUtil.string.trim(j.val());
		if (v && v != j[0].tip) {
			var data = {fullText: v};
			z.clearSearchResults('searching...');
			D.WebAPI.searchBookmarkbyFulltext(data, function(r) {
				
				z.doPopulateBookmarks(
					r.bookmarks, 
					diigoUtil.string.showTpl('<a class="link" href="#{0}">Search Results for "#{1}"</a>', [D.urls.getFullTextSearchURL(v, 'my'), v]), 
					null, 
					'See more on the web', 
					D.urls.getFullTextSearchURL(v, 'my')
				);
			});
			
			//remember last search term
			D.prefs.set('sidebar.searchTerm', v, true);
		} else {
			z.clearSearchResults();
		}
	},
	
	refreshBmresult:function() {
	},
	
	/**
	 * 
	 * @param {String} which 'my' | 'tag' | 'list' | 'search'
	 */
	selectBookmarkFilter:function(which) {
		var lastFilterTab = this.currentFilterTab;
		if (which&&this.currentFilterTab == which) return;
		else if(which == null) which=this.currentFilterTab;
		
		this.currentFilterTab = which;
		var i = this.filterTabs.indexOf(which == 'my' ? 'tag' : which);
		var j = this.jFilter;
		j.find('>legend:first a')
			.not(':eq(' + i + ')').removeClass('current')
			.end().eq(i).addClass('current');
		
		j.find('>div')
			.not(':eq(' + i + ')').hide()
			.end().eq(i).show();
			
		if (which == 'my'){
			if(!$('#diigo-unread').is(':checked')){
				this.populateMyBookmarks();
			}else{
				this.populateMyUnreadBookmarks();
			}
		}
		else if (which == 'tag')
			this.searchTag();
		else if (which == 'list')
			this.searchByList();
		else if (which == 'fullText') {
			/*if (lastFilterTab == 'tag') {
				//grab input from tag input
				j = $('#bm-search-input-tag'), v = diigoUtil.string.trim(j.val());
				if (v && v != j[0].tip) {
					$('#bm-search-input-fullText').val(v).removeClass('tip');
				}
			}*/
			
			this.searchFullText();
		}
	},
	
	populateMyBookmarks: function(refresh) {
		if (this.currentFilterTab == 'my') {
			this.doPopulateBookmarks(
				D.env.recentlySavedBookmarks, 
				diigoUtil.string.showTpl('<a class="link" href="#{0}">My Library</a>', [D.urls.getUserBookmarksPageURL()]), 
				null, 
				'See more on the web', 
				D.urls.getUserBookmarksPageURL()
			);
			
			if (refresh) {
				D.WebAPI.loadMyStuff('recentlySavedBookmarks',20);
			}
		}
	},
	isUnread: function() {
		return $('#diigo-unread').is(':checked');
	},
	
	populateMyUnreadBookmarks: function(refresh) {
		if (this.currentFilterTab == 'my') {
			this.doPopulateBookmarks(
				D.env.unreadBookmarks, 
				diigoUtil.string.showTpl('<a class="link" href="#{0}">Unread Bookmarks</a>', [D.urls.getUnreadBookmarksURL()]), 
				null, 
				'See more on the web', 
				D.urls.getUnreadBookmarksURL()
			);
			
			if (refresh) {
				D.WebAPI.loadMyStuff('unreadBookmarks',20);
			}
		}
	},
	
	clearSearchResults: function(title) {
		$('#bm-bmListTitle').text(title || 'ready to search');
		
		$('#bm-list-Bookmarks').html('');
		
		//more link
		$('#link-moreBookmarks').css({visibility: 'hidden'}); //.attr({href: D.urls.getUserBookmarksPageURL()});
	},
	
	doPopulateBookmarks: function(bookmarks, title, count, moreLinkText, moreLinkUrl) {
		//list title
		var j = $('#bm-bmListTitle');
		j.html(title);
		//Should not display count unless we support paging
		if (count != null) {
			j.append('<span> (COUNT)</span>'.replace('COUNT', count));
		}
		
		//ui
		$('#bm-list-Bookmarks').html(
			bookmarks.map(function(bm) {
				return diigoUtil.string.showTpl(templates.bookmark_html, {
					URL: bm.url,
					PRIVATE_STAR: bm.mode == D.PRIVACY_MODE_PRIVATE ? '' : 'display:none;',
					TITLE: bm.title,
					DATETIME: bm.datetime
				});
			}).join('\n')
		);
		
		//more link
		$('#link-moreBookmarks')
			.attr({href: moreLinkUrl})
			.text(moreLinkText + ' »')
			.css('visibility', 'visible');
	}
};
/**
 * The collapsable sections
 */
function initSections() {
	$('div.section>h2').click(function() {
		var j = $(this);
		var collapsed = j.toggleClass('collapsed').is('.collapsed');
		
		if (collapsed) {
			j.next('div').slideUp();
		} else {
			j.next('div').slideDown();
		}
		return false;
	});
}
/**
 * Fight against IE bug. IE triggers resize event when body size changes.
 * Need to detect whether the window size has really changed
 * http://snook.ca/archives/javascript/ie6_fires_onresize/
 * 
 */
function onResize() {
	var f = arguments.callee;
	var w = f.w, h = f.h;
	var ww = $(window).width(), hh = $(window).height();
	if (ww != w || hh != h) {
		adjustHeight();
	}
	f.w = ww; f.h = hh;
}
/**
 * Adjusts content size to fit viewport
 */
var adjustHeight = //diigoUtil.func.throttle(
function(pillar) {
	pillar = pillar || $('#tabContent-' + currentTab + ' .heightPillar');
	
	var pillarOffset = pillar.offset();
	
	offsetHeight=0;
	if(pillar[0])
		offsetHeight=pillar[0].offsetHeight;
	//pillarHeight += (winHeight - contentBottom)
	pillar.height(
		//$().height() causes flickering
		offsetHeight + 
		$(window).height() - 
		($('#diigo-sidebar').height() + $('#diigo-sidebar').offset().top) - 1
	);
};
//);
/**
 * Displays something when current tab is not applicable (e.g. This URL & about:blank)
 * Switches back to tab when applicable
 * 
 * This function calls selectTab which calls this. Becareful not to make never ending recursion.
 * 
 * @return {Boolean} whether the current tab is not applicable for current page
 */
function pageNotSupported() {
	var na = !isTabAvailable(currentTab); 
	if (na) {
		var j = $('#tabs-container1+div.tabContent>div').hide();
		adjustHeight($('#tabContent-pageNotSupported').show().find('>div.heightPillar'));
	} else if ($('#tabContent-pageNotSupported').is(':visible')) {
		selectTab(currentTab);
	}
	
	return na;
}
/**
 * Call me when current url changes
 */
function changeUrl(sync) {
	D.utils.dump('[SidebarPage] changeUrl');
	gContext = Sidebar.currentContext;
	
	//clear populated flags
	for (var k in populated) populated[k] = false;
	
	if (pageNotSupported()) return;
	
	function f() {
		populateThisUrl();
		
		AnnTab.prepareForNewUrl();
		populatePageComments();
		populateAnnotations();
		populateReaders();
	}
	
	if (sync)
		f();
	else
		setTimeout(f, 1);
}
function populateFriends() {
	var jLoading = $('#loading-friends').show();
	$('#noFriends').hide();
	doPopulate();
	D.WebAPI.loadMyFriends({}, doPopulate);
	
	$('#link-manageMyFriends').attr('href', D.urls.getMyFriendsURL());
	$('#link-inviteFriends').attr({'href': D.urls.getInviteFriendsURL()});
	$('#link-findFriends').attr('href', D.urls.getFindFriendsURL());
	//$('#link-browsePeople').attr({'href': D.urls.getBrowsePeopleURL()});
	
	function doPopulate() {
		jLoading.hide();
		$('#noFriends')[D.env.myFriends.length > 0 ? 'hide' : 'show']();
		
		$('#tabContent-friends>div>div>ul._list').html(
			D.env.myFriends.map(function(v) {
				return diigoUtil.string.showTpl(templates.friend_html, {
					USERNAME: v.name,
					REALNAME: v.realName,
					LOCATION: v.location,
					ONLINE_CLASS: v.online ? 'online' : '',
					USER_URL: D.urls.getUserHomepageURL(v.name),
					AVATAR_URL: D.urls.getUserAvatarURL(v.name),
					RECENT_BOOKMARK_TITLE: v.recentBookmark.title,
					RECENT_BOOKMARK_URL: v.recentBookmark.url,
					RECENT_BOOKMARK_DATETIME: v.recentBookmark.datetime,
					SEND_MESSAGE_ONCLICK: 'event.stopPropagation(); event.preventDefault(); D.handle(\'sendTo\', \'USERNAME\')'.replace('USERNAME', v.name),
					MSG_SUBJECT: diigoUtil.string.stripTags(v.msg.subject),
					MSG_BODY: diigoUtil.string.stripTags(v.msg.body),
					MSG_URL: D.urls.getMessageURL(v.name, v.msg.id),
					MSG_DATETIME: v.msg.datetime,
					SEND_MSG_URL: D.urls.getSendMessageToUserURL(v.name) //may not be needed 2007-12-08 18:25:57 UTC
				});
			}).join('\n')
		);
		
	}
}
function populateCached() {
	var bm = gContext.bookmark;
	j=$('a.cached').attr('href', D.urls.getCachedPageURL(bm.url));
	if(bm.cached==2){
		j.text("Snapshot");
		j.show();
	}else if(bm.cached==1){
		j.text("Snapshot");
		j.show();
	}else{
		j.hide();
	}
}
/**
 * Update title, url, tags, description, ...
 */
function populateThisUrl(force) {
	if (!(currentTab == 'readers' || currentTab == 'annotations') || (populated.thisUrl && !force)) return;
	//
	var bm = gContext.bookmark;
	var j = $('#currentPageTitle')
		.toggleClass('bookmarked', bm.saved)
		.find('>span._pageTitle').text(bm.title || 'Untitled');
		
	populateCached();
	
	//* for private bookmark
	//if (bm.mode == D.PRIVACY_MODE_PRIVATE && bm.saved) {
		$('#currentPageTitle>span._privateStar').css('display', (bm.mode == D.PRIVACY_MODE_PRIVATE && bm.saved) ? '' : 'none');	
	//}
	 
	$('#currentUrl').attr({href: bm.url}).text(bm.url);
	 
	j = $('#currentTags').html('');
	
	if (bm.saved) {
		j.html('My Tags: ' + bm.tags.map(function(t) {
			return diigoUtil.string.showTpl('<a class="link" href="#{0}">#{1}</a>', [D.urls.getUserTagURL(D.env.user, t), t]);
		}).join(','));
	}
	 
	$('#currentPageDescription').text(bm.saved && bm.description ? 'My Description: ' + bm.description : '');
	
	populated.thisUrl = true;
	
	if(!D.isCurrentLocationBookmarkable()){
		$('.iconBookmark').hide();
	}else{
		$('.iconBookmark').show();
	}
	
	adjustHeight();
}
/**
 * Asynchronous wrapper to avoid tab switching lag
 */
function populateReaders_async(force) {
	setTimeout(function() {populateReaders(force);}, 1);	
}
function populateReaders(force) {
	if (currentTab != 'readers' || (populated.readers && !force)) return;
	
	populated.readers = gContext.readersLoaded;
	
	var jLoading = $('#loading-readers');
	if (!gContext.readersLoaded) {
		jLoading.show();
	} else {
		jLoading.hide();
	}
	
//	if (!gContext.readersLoaded) {
//		D.WebAPI.loadReaders(gContext.bookmark.url, gContext);
//		
//		//do not return, show empty reader list before data loads
//		//return;
//		
//	}	
	
	function buildReaderList(listEle, readers) {
		$(listEle).html(
			readers.map(function(r) {
				return diigoUtil.string.showTpl(templates.reader_html, {
					USERNAME: r.name,
					REALNAME: r.realName,
					LOCATION: r.location,
					ONLINE_CLASS: r.online ? 'online' : '',
					USER_URL: D.urls.getUserHomepageURL(r.name),
					USER_BOOKMARK_URL: D.urls.getUserBookmarksPageURL(r.name),
					AVATAR_URL: D.urls.getUserAvatarURL(r.name),
					RECENT_BOOKMARK_TITLE: r.recentBookmark.title,
					RECENT_BOOKMARK_URL: r.recentBookmark.url ,
					RECENT_BOOKMARK_DATETIME: r.recentBookmark.datetime ,
				});
			}).join('\n')
		);
	}
				
	//page reader
	j=$('#list-pageReaders+p.moreLink a')
	.attr({href: D.urls.getPageReadersURL(gContext.bookmark.url)});
	buildReaderList('#list-pageReaders', gContext.pageReaders);
	if(gContext.pageReaderCount&&gContext.pageReaderCount>0){
		$('#header-pageReaders').find('span').text(gContext.pageReaderCount+" Readers for this page");
		j.show();
	}else{
		$('#header-pageReaders').find('span').text("No reader for this page");
		j.hide();
	}
	
	//site reader
	j=$('#list-siteReaders+p.moreLink a')
	.attr({href: D.urls.getSiteReadersURL(gContext.siteDomain)});
	buildReaderList('#list-siteReaders', gContext.siteReaders);
	if(gContext.siteReaders&&gContext.siteReaderCount>0){
		$('#header-siteReaders').find('span').text(gContext.siteReaderCount+" Readers of "+gContext.siteDomain);
		j.show();
	}else{
		$('#header-siteReaders').find('span').text("No reader of "+gContext.siteDomain);
		j.hide();
	}
}
/**
 * Asynchronous wrapper to avoid tab switching lag
 */
function populateAnnotations_async(force) {
	setTimeout(function() {populateAnnotations(force);}, 1);	
}
function populateAnnotations(force) {
	//D.utils.dump('populateAnntations called');
	
	if (currentTab != 'annotations' || (populated.annotations && !force)) {
		if (force) populated.annotations = false;
		return;
	}
	
	if (!gContext) return;
	
	//D.utils.dump('populateAnntations doing...');
	AnnTab.populateAnnotations();
	populated.annotations = true;
}
function populatePageComments_async(force) {
	setTimeout(function() {populatePageComments(force);}, 1);	
}
function populatePageComments(force) {
	//D.utils.dump('populateAnntations called');
	
	if (currentTab != 'annotations' || (populated.pageComments && !force)) {
		if (force) populated.pageComments = false;
		return;
	}
	
	if (!gContext) return;
	
	//D.utils.dump('populateAnntations doing...');
	AnnTab.populatePageComments();
	populated.pageComments = true;
}
/*================ Annotation ==================*/
var AnnTab = {
	filterMode: '_all', /*_all _noGroups _private _public groupName*/
	jPcSec: null, /*page comment section*/
	jAnnSec: null,
	
	/**
	 * jquery .html() calls .empty() which unbinds events
	 * Make sure you dettach editor before .empty() is called upon a parent
	 */
	editor: (function() {
		return {
			jEdit: null,
			info: null, //what are we edition? see parameter of show()
			
			init: function() {
				var z = this;
				var t = document.createElement('ul');
				t.innerHTML = templates.editComment_html;
				z.jEdit = $(t.getElementsByTagName('li')[0]);
				
				z.jEdit.find('input[name="ok"]').click(function() {
					z.submit();
				})
				.end().find('textarea').keypress(function(event) {
					if (event.keyCode == 13 && event.ctrlKey) // Ctrl + Enter
						z.submit();
				})
				.end().find('input[name="cancel"]').click(function() {
					z.remove();
				});
				
			},
			
			submit: function() {
				var z = this;
				
				//do nothing if the content is empty
				var content = z.jEdit.find('textarea').val();
				if (!content) {
					D.notifyError(D.strings.getString('comment.input.content'));
					return;
				}
				
				//determine privacy mode
				var t = z.jEdit.find('select').val(), mode, groupName;
				if (t == '_private') {
					mode = 2;
				} else if (t == '_public') {
					mode = 0;
				} else {
					groupName = t;
				}
				
				if (z.info.what == 'pc') {
					//adding a page comment
					var data = {
						urlId: gContext.bookmark.urlId,
						mode: mode,
						content: content
					};
					
					if (groupName) {
						data.justForGroups = true;
						data.groups = [groupName];
					}
					D.WebAPI.addPageComment(data, gContext);
				} else {
					//adding an inline comment
					var data = {
						annotationId: z.info.annId,
						mode: mode,
						content: content
					};
					
					if (groupName) {
						data.justForGroups = true;
						data.groups = [groupName];
					}
					D.WebAPI.addInlineComment(data, gContext);
				}
				
				z.remove();
			},
			
			remove: function() {
				if (this.jEdit[0]&&!this.jEdit[0].parentNode) return;
				
				var listBox = this.jEdit.parents('div.listBox:first');
				//restore empty class
				listBox.toggleClass('emptyListBox', listBox.find('>ul>li._comment').length == 0);
			
				this.jEdit[0].parentNode.removeChild(this.jEdit[0]);
			},
			
			/**
			 * show the edit comment UI
			 * @param {Object} info {what: 'pc'/'ic', annId: 'annotationId'}
			 */
			show: function(info) {
			  this.info = info = info || this.info;
			  
			  if (info.what == 'ic')
				  var ann = D.Annotation.find(gContext, info.annId);
				  
			  //find the .listBox
			  var listBox = info.what == 'pc' ? AnnTab.jPcSec.find('>div.listBox') : $('#' + AnnTab.eleId_ann(ann));
			  
				//TODO privacy selection
				var j = this.jEdit.find('select._optionPrivacy').empty();
				
				var filterMode = AnnTab.filterMode;
				//option cadidates
				//public
				if ((filterMode == '_all' || filterMode == '_public') &&
						//!D.isSelectedURL(gContext.bookmark.url) &&
						//(ann ? D.publicAnnotationsAllowed(gContext.bookmark.url) : true) &&
						(ann ? !ann.onlyInGroup && ann.getComments('_private').length == 0 : true) //no private ic						
				) 
				{
					j.append('<option value="_public">Public</option>');
				}
				
				//private
				if ((filterMode == '_all' || filterMode == '_private'|| filterMode == '_nonepublic') &&
						(ann ? !ann.onlyInGroup && ann.getComments('_public').length == 0 : true)) 
				{
					j.append('<option value="_private">Private</option>');
				}
				
				//groups
				var jOptgroup = $('<optgroup label="Groups" style="padding-left:3px"></optgroup>').appendTo(j);
				D.env.myGroups.forEach(function(g) {
					if ((filterMode == '_all' || filterMode == g.name|| filterMode == '_nonepublic') &&
							(ann && (ann.user != D.env.user || ann.onlyInGroup) ? ann.inGroup(g.name) : true)) 
					{
						jOptgroup.append(diigoUtil.dom.buildOne('option', {value: g.name}, [g.displayName]));
					}
				});
				if (jOptgroup.find('option').length == 0) jOptgroup.remove();
				
				//select the default option
				if (filterMode == '_all' && ann && ann.isPrivate()) {
					j.val('_private');
				}
				
				if (info.what == 'ic'){
					j.show();
				}else{
					j.hide();
				}
				
				if (j.find('option').length == 0) {
					alert('You are not allowed to add comment here.');
					return;
				}
				
				this.jEdit.prependTo(listBox.removeClass('emptyListBox').find('>ul'));
				
				//clear text
				if(j.val()=="_public"&&!D.publicAnnotationsAllowed(gContext.bookmark.url)&&info.what == 'ic'){
					this.jEdit.find('textarea')
					.val("")
					.attr({disabled:true});
					this.jEdit.find('input._commentOK').attr({disabled:true});
				}else{
					this.jEdit.find('textarea').val('').focus();
				}
				
			}
		};
	})(),
	
	init: function() {
		var z = this;
		
		this.jPcSec = $('#sec-pc');
		this.jAnnSec = $('#sec-ann');
		this.filterMode=D.prefs.val('filter');
		if(typeof this.filterMode!="string"){
			D.prefs.val('filter','_all');
			this.filterMode='_all';
		}
		
		this.editor.init();
		
		//view filter
		var j = $('#viewFilter');
		j.find('>a')
			.click(function() {z.showFilterMenu();})
		.end().find('>ul')
//			.bind('mouseleave', function() {
//				$(this).hide();
//			})
			.click(function(event) {
				var j = $(event.target);
				if (j.is('li') && j.attr('val') != z.filterMode) {
					z.switchFilterMode(j.attr('val'), true);
				}
				$(this).hide();
			}).hide();
		
		j.find('>a')[0].firstChild.nodeValue = j.find('ul li[val=' + this.filterMode + ']').text();
	},
	
	switchFilterMode: function(filterMode, refresh) {
		this.filterMode = filterMode;
		D.prefs.val('filter',filterMode);
		D.runtime._focusedContext=D.getCurrentContext();
		D.runtime._focusedContext.filterMode=filterMode;
		
		var j = $('#viewFilter');
		j.find('>a')[0].firstChild.nodeValue = j.find('ul li[val=' + filterMode + ']').text();
		
		if (refresh) {
			this.prepareForNewUrl();
			populatePageComments(true);
			populateAnnotations(true);
			if(filterMode == '_none'){
				D.handle('toggleHighlight',true);
			}else{
				D.handle('toggleHighlight',false);
				gContext.unpaintAllAnnotations();
				gContext.paintAllAnnotations();
			}
		}
	},
	
	refreshGroups: function() {
		var j = $('#viewFilter>ul');
		j.find('li._group').remove();
		D.env.myGroups.forEach(function(g) {
			j.append(diigoUtil.dom.buildOne('li', {val: g.name, 'class': '_group'}, [g.displayName]));
		});
		j = $('#viewFilter');
		j.find('>a')[0].firstChild.nodeValue = j.find('ul li[val=' + this.filterMode + ']').text();
	},	
	/**
	 * Show the view filter drop-down menu
	 * <li value="_all">All</li>
	 * ...
	 * <li class="_group" value="groupName">Group display name</li>
	 */
	showFilterMenu: function() {
		var j = $('#viewFilter>ul');
		if (j.is(':visible')) {
			j.hide();
		} else {
			j.find('li._group').remove();
			D.env.myGroups.forEach(function(g) {
				j.append(diigoUtil.dom.buildOne('li', {val: g.name, 'class': '_group'}, [g.displayName]));
			});
			j.show();
			
			//clicking any part in the page should hide the menu
			//delay because the click event bubbles up to document right after showing
			setTimeout(function() {$(document).one('click', function() {j.hide();})}, 50);
		}
	},
	
	/**
	 * Gets filtered ann/pc/ic according to current filter mode
	 */
	_getFilteredItems: function (items) {
	  var z = this;
	  return items.filter(function (item) {
	    return item.matchFilter(z.filterMode);
	  });
	},
	
	/**
	 * Get the LABELS_HTML for pc/ic
	 * <p class="labelList">#{LABELS_HTML}</p>
	 */
	_labelsHtml: function(c) {
		var commentType = c.annotationId ? 'ic' : 'pc';
	  var filter = this.filterMode, 
	  		html = '',
	  		delHtml = c.canDelete() ? '<a href="javascript:void(0)" class="btnComment btnDel" onclick="#{ONCLICK};"><img src="../skin/spacer.gif" style="width:10px;height:10px" alt="" /></a>' : '';
	  		
	  //public
	  if (c.isPublic() && 
			  //!D.isSelectedURL(gContext.bookmark.url) &&
			  (filter == '_all' || filter == '_public') && 
			  c.user == D.env.user) {
	  	html += '<label class="_public"><span>Public</span>DEL</label>'
	  		.replace('DEL', diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ")"}));  
	  }
	  
	  //private
	  if (c.isPrivate() && (filter == '_all' || filter == '_private' || filter == '_nonepublic')) {
	  	html += '<label class="_private"><span>Private</span>DEL</label>'
	  		.replace('DEL', diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ")"}));  
	  }
	  
	  //groups
	  c.groups.forEach(function (g) {
	    if (filter == g.name || filter == '_all' || filter == '_nonepublic') {
	      html += diigoUtil.string.showTpl('<label class="_#{GROUP_NAME}"><a href="#{GROUP_URL}" class="link">#{GROUP_DISPLAY_NAME}</a>#{DEL}</label>', {
	        GROUP_NAME: g.name,
	        GROUP_DISPLAY_NAME: g.displayName,
	        GROUP_URL: D.urls.getGroupURL(g.name),
	        DEL: diigoUtil.string.showTpl(delHtml, {ONCLICK: "AnnTab.onclick_del_" + commentType + "(event, " + c.id + ", '" + g.name + "')"})
	      });
	    }
	  });
	  
	  return html;
	},
	
	/**
	 * Get unique element id for model objects
	 */
	eleId_pc: function(c) {
		return '_pc_' + c.id;	
	},
	
	eleId_ic: function(c) {
		return '_ic_' + c.id;
	},
	
	/**
	 * _ann_#{h_id}
	 * or
	 * _ann_#{h_id}_g_#{groupName}
	 */
	eleId_ann: function(ann) {
		var id = '_ann_' + ann.id;
		return id;
	},
	
	/**
	 * @public
	 * Shows the Add Comment UI in public section
	 */
	goAddPageComment: function() {
		this.editor.show({what: 'pc'});
	},
	
	
	/**
	 * When the url is changed, call this before AnnTab.populatePageComments/AnnTab.populateAnnotations
	 */
	prepareForNewUrl: function() {
		this.editor.remove();
	},
	
	//Batch UI update
	populatePageComments: function() {
		var z = this;
		var comments = z._getFilteredItems(gContext.pageComments);
		
		//restore editor after populating (Toolbar button comment)
		var editorContainer = z.editor.jEdit.parents('div.listBox.pc');
		
		//jquery .empty() unbinds events. keep editor away from it
		z.editor.remove();
		
		//page comments
		var list = z.jPcSec.find('div.listBox').toggleClass('emptyListBox', comments.length == 0);
		var ul = list.find('ul.listContent').empty();
		comments.forEach(function(c) {
			z._domAddPageComment(c, ul[0]); 
		});
		
		if (editorContainer.length > 0)
			z.editor.show();
	},
	
	populateAnnotations: function() {
		var z = this;
		
		//jquery .empty() unbinds events. keep editor away from it
		z.editor.remove();
		
		z.jAnnSec.find('>div.annBox').empty();
		
		z._getFilteredItems(gContext.annotations).forEach(function (ann) {
		  z.addAnnotation(ann);
		});
	},
	
	/**
	 * Incremental UI update
	 */
	addPageComment: function(c, groupName) {
		var z = this;
		if (!c.matchFilter(z.filterMode)) return;
		
		var li = document.getElementById(z.eleId_pc(c));
		if (!li) {
		  //create element
			var list = z.jPcSec.find('div.listBox');
			var ul = list.find('ul.listContent');
			li = z._domAddPageComment(c, ul[0]);
			list.removeClass('emptyListBox');
		} else if (groupName) {
		  //the element is already there, update labels to reflect group changes
		  $(li).find('p.labelList').html(z._labelsHtml(c));
		}
	},
	
	//returns the li
	_domAddPageComment: function(c, ul) {
	  var z = this;
	  
	  var html = diigoUtil.string.showTpl(templates.comment_html, {
			ID: z.eleId_pc(c),
			CLASS_EDITABLE: c.canDelete() ? 'editable' : '',
			ONLINE_CLASS: c.userOnline ? 'online' : '',
			CLASS_IC_OR_PC: '_pc',
			USER: c.user,
			REALNAME: c.realName,
			USER_URL: D.urls.getUserHomepageURL(c.user),
			USER_AVATAR_URL: D.urls.getUserAvatarURL(c.user),
			DATETIME: c.datetime,
			LABELS_HTML: z._labelsHtml(c),
			CONTENT: diigoUtil.content2Html(c.content)
		});
		
		return prependFrag(ul, html);
	},
	
	/**
	 * first remove labels
	 * when no labels left, remove the element
	 */
	removePageComment: function(c, groupName) {
		var j = $('#' + this.eleId_pc(c));
		if (j.length == 0) return;
		
		var labelList = j.find('p.labelList label');
		if (groupName) {
		  //removing from a group
		  labelList.remove('label._' + groupName);
		} else {
		  //removing from smasher
		  labelList.remove('label._public').remove('label._private');
		}
		
		if (j.find('p.labelList label').length == 0) {
		  //no labels left, remove the element
		  var ul = j.parent('ul');
		  j.remove();
		  ul.parent().toggleClass('emptyListBox', ul.find('>li._comment').length == 0);
		}
	},
	
	addInlineComment: function(c) {
		var z = this;
		if (!c.matchFilter(z.filterMode)) return;
		
		var j = $('#' + z.eleId_ic(c));
		if (j.length == 0) {
			var ann = c.getAnnotation();
			var list = $('#' + z.eleId_ann(ann));
			var ul = list.find('ul.listContent');
			
			var html = diigoUtil.string.showTpl(templates.comment_html, {
				ID: z.eleId_ic(c),
				CLASS_EDITABLE: c.canDelete() ? 'editable' : '',
				ONLINE_CLASS: c.userOnline ? 'online' : '',
				CLASS_IC_OR_PC: '_ic',
				USER: c.user,
				REALNAME: c.realName,
				USER_URL: D.urls.getUserHomepageURL(c.user),
				USER_AVATAR_URL: D.urls.getUserAvatarURL(c.user),
				DATETIME: c.datetime,
				LABELS_HTML: z._labelsHtml(c),
				CONTENT: diigoUtil.content2Html(c.content)
			});
			
			var li = appendFrag(ul[0], html);
			list.removeClass('emptyListBox');
			return li;
		}
	},
	
	removeInlineComment: function(c, groupName) {
		var z = this;
		
		var j = $('#' + this.eleId_ic(c));
		if (j.length == 0) return;
		
		var labelList = j.find('p.labelList label');
		if (groupName) {
		  //removing from a group
		  labelList.remove('label._' + groupName);
		} else {
		  //removing from smasher
		  labelList.remove('label._public').remove('label._private');
		}
		
		if (j.find('p.labelList label').length == 0) {
		  //no labels left, remove the element
		  var ul = j.parent('ul');
		  j.remove();
		  ul.parent()
		  .toggleClass('emptyListBox', ul.find('>li._comment').length == 0)
		  .toggleClass('editable', c.getAnnotation().canDelete(z.filterMode));
		}
		
	},
	
	addAnnotation: function(ann, groupName) {
		var z = this;
		if (!ann.matchFilter(z.filterMode)) return;
		
		var j = $('#' + z.eleId_ann(ann));
		if (j.length == 0) {
			var annTypeClass = '';
			var content = '';
			
			var comments = ann.getComments(z.filterMode);
			
			if (ann.type == D.ANNOTATION_TYPE_TEXT) { 
				content = diigoUtil.string.stripTags(ann.content);
			} else if (ann.type == D.ANNOTATION_TYPE_IMAGE) { 
				annTypeClass = 'imgHighlight';
				content = '(image)';
			} else if (ann.type == D.ANNOTATION_TYPE_FLOATNOTE) { 
				annTypeClass = 'floatNote';
				content = '(floating sticky note)';
			} else if (ann.type == D.ANNOTATION_TYPE_FLASH) { 
				annTypeClass = 'flash';
				content = '(flash movie)';
			} else if (ann.type == D.ANNOTATION_TYPE_VIDEO) { 
				annTypeClass = 'video';
				content = '(video)';
			}
				
			var html = diigoUtil.string.showTpl(templates.ann_html, {
				ID: z.eleId_ann(ann),
				ANN_TYPE_CLASS: annTypeClass,
				EMPTY_CLASS: comments.length > 0 ? '' : 'emptyListBox',
				CLASS_EDITABLE: ann.canDelete(z.filterMode) ? 'editable' : '',
				CLASS_CAN_ADD_COMMENTS: ann.canAddComments() ? 'canAddComments' : '',
				CONTENT: content,
				COMMENT_ITEMS: '',
				ON_CLICK_DEL: 'AnnTab.onclick_del_ann(event, \'' + ann.id + '\');',
				ON_CLICK_ADD_IC: 'AnnTab.onclick_add_ic(event, \'' + ann.id + '\');',
				ON_CLICK_JUMP_TO: 'AnnTab.onclick_ann_jumpTo(event, \'' + ann.id + '\');'
			});
			
			var ret = appendFrag(z.jAnnSec.find('div.annBox')[0], html);
			comments.forEach(function(c) {
				z.addInlineComment(c);
			});
			return ret;
		}
		
	},
	
	//TODO
	removeAnnotation: function(ann, groupName) {
		var id = this.eleId_ann(ann);
		var j = $('#' + id);
		if (j.length > 0 && !ann.matchFilter(this.filterMode)) j.remove();
	},
	//context event listeners
	onpc_del: function(c, groupName) {
		//D.utils.dump('[sidebar window]: onpc_del', c);
		this.removePageComment(c, groupName);
	},
	
	onpc_add: function(c, groupName) {
		this.addPageComment(c, groupName);
	},
	
	onic_add: function(c, groupName) {
		this.addInlineComment(c, groupName);
	},
	
	onic_del: function(c, groupName) {
		this.removeInlineComment(c, groupName);
	},
	
	onann_add: function(ann, groupName) {
		this.addAnnotation(ann, groupName);
	},
	
	onann_changeMode: function(ann) {
		this.removeAnnotation(ann);
		this.addAnnotation(ann);
	},
	
	onann_del: function(ann, groupName) {
		this.removeAnnotation(ann, groupName);
	},
	
	//onclick handlers for some sidebar buttons
	onclick_add_pc: function(event) {
	  this.goAddPageComment(); 
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	//X
	onclick_del_pc: function(event, id, groupName) {
		D.PageComment.del(gContext, id, groupName);
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	onclick_add_ic: function(event, annId) {
	  this.editor.show({what: 'ic', annId: annId});
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	//X
	onclick_del_ic: function(event, id, groupName) {
		D.InlineComment.del(gContext, id, groupName);
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	onclick_del_ann: function(event, annId) {
		var z = this, filter = z.filterMode, from = [];
		var ann = D.Annotation.find(gContext, annId);
		
		if (filter == '_all') {
			if (!ann.onlyInGroup) from.push(null); //from smasher
			ann.groups.forEach(function(g) {from.push(g.name);});
		} else if (filter == '_public' || filter == '_private') {
			if (!ann.onlyInGroup) from.push(null);  //from smasher
		} else {
			from.push(filter); //filter is the group name
		}
		
		from.forEach(function(a) {D.Annotation.del(gContext, annId, a);});
		
	  event.stopPropagation(); 
	  event.preventDefault();
	},
	
	onclick_ann_jumpTo: function(event, annId) {
	  D.Annotation.find(gContext, annId).jumpHere(true, false);
	  event.stopPropagation(); 
	  event.preventDefault();
	}
	
};
/*========== utils ===========*/
//function appendItem(_parent, tpl, data, callback, thiz) {
//	var html = diigoUtil.string.showTpl(tpl, data);
//	var j = $(appendFrag(_parent, html));
//	
//	if (callback) callback.call(thiz, j);
//	return j;	
//}
/**
 * Appends a document fragment to an element and returns the last child.
 * The appended fragment is supposed to be a single element
 */
function appendFrag(contextElement, html) {
	return domManipFragment(contextElement, html, function(frag) {
		contextElement.appendChild(frag);
	});
}
function prependFrag(contextElement, html) {
	return domManipFragment(contextElement, html, function(frag) {
		contextElement.insertBefore( frag, contextElement.firstChild );
	});
}
function domManipFragment(contextElement, html, fn) {
	var r = document.createRange();
	r.selectNode(contextElement);
	var f = r.createContextualFragment(html);
	
	//frag.lastChild will become null after appendChild, so remember it here.
	var last = f.lastChild;
	
	//get the last element node
	while (last = last.previousSibling)
		if (last.nodeType == 1) break;
	
	fn(f);
	return last;
}
/**
 * Usage: new SelfEvidentTextBox();
 */
function SelfEvidentTextBox(ele, tip) {
	var j = $(ele);
	j[0].tip = tip = tip || j.val();
	j.focus(function() {
		if (j.val() == tip) {
			j.removeClass('tip').val('');
		}
	});
	
	j.blur(function() {
		if (j.val() == '') {
			j.addClass('tip').val(tip);
		}
	});
	
	j[0].getValue = function() {
		return this.value == tip ? '' : this.value;
	}
}
function openUrl(url) {
	D.utils.firefox.openAndReuseOneTabPerURL(url);
}