/////////////////////////////////////////////////////////////////////////////////




D.TwitterOAuth = {
    URL_OAUTH_BASE: 'http://twitter.com/oauth/',
    URL_API_BASE: 'http://api.twitter.com/1/',
    comsuerKey: 'zBUnfoKzNEHePv1d7qlw',
    consumerSecret: '6iqx5cwskVF3ulQoRad4f5EKL8fZRPqHd7kOeIAhC28',
    token: null,
    
    init: function() {
        var z = this;
        z.token=D.env.twitterToken;
        //z.reset();
        //z.changeUser();
    },
        
    /**
     * 
     * @param {Object} {method: 'POST', url: 'request_token', params: {}, successCallback: func, errorCallback: func, oauth: false}
     */
    makeRequest: function(options) {
        var o = options;
        var z = this;
        var baseUrl = o.oauth ? z.URL_OAUTH_BASE : z.URL_API_BASE;
        var message = { 
            method: o.method || 'POST', 
            action: baseUrl + o.url, 
            parameters: { 
                oauth_signature_method: 'HMAC-SHA1', 
                oauth_consumer_key: z.comsuerKey
            }
         };
         
         var accessor = { 
            consumerSecret: z.consumerSecret, 
            tokenSecret: z.token.oauth_token_secret
         };
         
         if(z.token.oauth_token) {
            OAuth.setParameter(message, 'oauth_token', z.token.oauth_token);
         }
         
         if (o.params) {
             for (var p in o.params) {
                 OAuth.setParameter(message, p, o.params[p]);
             }
         }
         
         OAuth.completeRequest(message, accessor);

         D.$.ajax({
             type: message.method,
             url: message.action,
             timeout: 60000,
             data: OAuth.getParameterMap(message.parameters),
             complete: function(xhr, textStatus) {
                 D.utils.dump('[WebAPI request]oauth complete', textStatus, xhr);
             },
             success: function (data, textStatus, xhr) {
                 D.utils.dump('[WebAPI request]oauth success', data, textStatus, xhr);
                 if (o.successCallback) o.successCallback.call(z, data);
             },
             error: function(xhr, textStatus, err) {
                 D.utils.dump('[WebAPI request]oauth error', xhr, textStatus, err);
                 if (o.errorCallback) o.errorCallback.call(z, xhr, textStatus, err);
             }
         });
    },
    
    
    getRequestToken: function() {
        var z = this;
        var options = {
            url: 'request_token',
            oauth: true,
            method: 'GET',
            successCallback: function(data) {
                var res = OAuth.getParameterMap(data);
                
                if (!'oauth_token oauth_token_secret'.split(' ').every(function(k) {
                    return !!res[k];
                })) {
                    D.utils.dump('[WebAPI request][oauth request token error]. data not correct', data);
                    return null;
                }
                z.token.oauth_token = res['oauth_token'];
                z.token.oauth_token_secret = res['oauth_token_secret'];
                 
                D.utils.firefox.loadTwitterinTab(z.URL_OAUTH_BASE + 'authorize?oauth_token=' + z.token.oauth_token,
                function(tabBrowser){
                    z.oauthPinTab = tabBrowser;
                    tabBrowser.addEventListener("load", z.onLoadTwitterAuthor, true);
                });
                window.minimize();
            },
            
            errorCallback: function(xhr, textStatus, err) {
                var z = this;
                D.utils.dump('[WebAPI request][oauth request_token] failed', xhr, textStatus, err);
                z.reset();
            }
        };
        z.makeRequest(options);
    },
    
    onLoadTwitterAuthor: function(e){
		var doc = e.originalTarget;
		//just for document
		if (doc.nodeName != '#document') return;
		
		setTimeout(function(){
			if(doc.__diigo){
				var ctx=doc.__diigo;
				if(D.TwitterOAuth
						&&D.TwitterOAuth.oauthPinTab
						&&/twitter.com\/oauth\/authorize$/.test(ctx.url)
						){
					var pinNum=ctx.$.trim(ctx.$("#oauth_pin").text());
					D.TwitterOAuth.getAccessToken(pinNum);
				}
			}
		},500);
    },
    
    getAccessToken: function(pin) {
        var z = this;
        D.utils.dump('[WebAPI request] got pin', pin);
        if (!pin) {
            alert('Authentication with twitter failed!');
            z.reset();
            return;
        }
        if(z.oauthPinTab){
        	D.utils.firefox.closeTab();
        }

        z.makeRequest({
            url: 'access_token',
            method: 'POST',
            oauth: true,
            params: {
                oauth_verifier: pin
            },
            
            successCallback: function(data) {
                var paramMap = OAuth.getParameterMap(data);
                if (!'oauth_token oauth_token_secret user_id screen_name'.split(' ').every(function(k) {
                    return !!paramMap[k];
                })) {
                    D.utils.dump('[WebAPI request][oauth access_token] failed', data);
                    z.reset();
                    return;
                }
                
                  //z.oauthTokenData.save(data);
                z.token.oauth_token = paramMap['oauth_token'];
                z.token.oauth_token_secret = paramMap['oauth_token_secret'];
                z.token.user_id = paramMap['user_id'];
                z.token.screen_name = paramMap['screen_name'];
                z.token.authenticated = true;
                  
                resetTwitterInfo();
                  
            },
            
            errorCallback: function(xhr, textStatus, err) {
                var z = this;
                D.utils.dump('[WebAPI request][oauth access_token] failed', xhr, textStatus, err);
                z.reset();
            }
        });
    },
    
    reset: function() {
        var z = this;
        z.token.oauth_token = null;
        z.token.oauth_token_secret = null;
        if(z.token.oauthPinTab)
        	z.token.oauthPinTab.removeEventListener("load", z.onLoadTwitterAuthor);
        z.token.oauthPinTab = null;
        //chrome.tabs.onUpdated.removeListener(z.tagUpdatededListener);
    },
    
    changeUser: function() {
        var z = this;
        z.reset();
        z.getRequestToken();
    },
    
    rot13: function(input){ //v1.0
        return input.replace(/[a-zA-Z]/g, function(c){
            return String.fromCharCode((c <= "Z" ? 90 : 122) >= (c = c.charCodeAt(0) + 13) ? c : c - 26);
        });
    },
        
    checkAuthentication: function() {
        var z = this;
        return (z.token.oauth_token || z.token.user_id) && {screen_name: z.token.screen_name};
    },
    
    API_statuses_home_timeline: function() {
        var z = this;
        z.makeRequest({
            url: 'statuses/home_timeline.json',
            method: 'GET',
            params: {
                count: 3
            },
            successCallback: function(data) {
                D.utils.dump('[twitter home timeline]', data);
            }
        });
    },
    
    API_friendships_exists: function() {
        var z = this;
        z.makeRequest({
            url: 'friendships/exists.json',
            method: 'GET',
            params: {
                user_a: z.screen_name,
                user_b: 'diigo'
            },
            successCallback: function(data) {
                D.utils.dump('[twitter friendships_exists]', data);
            }
        });
    },
    
    updateStatus: function(statusObj, callback) {
        this.API_statuses_update(statusObj, callback);
    },
    
    API_statuses_update: function(statusObj, callback) {
        var z = this;
        z.makeRequest({
            url: 'statuses/update.json',
            method: 'POST',
            params: {
                status: statusObj.status
            },
            successCallback: function(data) {
                D.utils.dump('[twitter statuses_update]', data);
                callback(data);
            },
            errorCallback: function(xhr, textStatus, err) {
                callback(null);
            }
        });
    }
    
};