var mainWindow = window.opener;
var D = mainWindow.diigo;

var context = D.getCurrentContext();
var Tw = D.TwitterThis;
var bm = window.arguments[0] || (context?context.bookmark:null);
if(bm)
	context = bm.context;

var jTxtMsg;
$(function() {
	//window.sizeToContent();
	jTxtMsg = $('#txt-message').bind('input', updateCountDown);
	defaultMsg();
	
	D.TwitterOAuth.init();
	if(D.TwitterOAuth.checkAuthentication()){
		$('#box-twitter-change').attr({
			"hidden":false});
		$('#box-twitter-change-user').attr({
			"value":"Signed in as "+D.TwitterOAuth.token.screen_name
		});
		$('#box-twitter-signin').attr("hidden",true);
	}else{
		$('#box-twitter-change').attr({
			"hidden":true});
		$('#box-twitter-change-user').attr({
			"value":""
		});
		$('#box-twitter-signin').attr("hidden",false);
		$('#box-twitter-loading').attr("hidden",true);
		$('#box-twitter-connect').attr("value","Click here to connect to twitter");
	}
});

function signinTwitter(){
	$('#box-twitter-loading').attr("hidden",false);
	$('#box-twitter-connect').attr("value","Loading...");
	D.TwitterOAuth.changeUser();
}

function resetTwitterInfo(){
	if(D.TwitterOAuth.checkAuthentication()){
		$('#box-twitter-change').attr({
			"hidden":false});
		$('#box-twitter-change-user').attr({
			"value":"Signed in as "+D.TwitterOAuth.token.screen_name
		});
		$('#box-twitter-signin').attr("hidden",true);
	}
	window.focus();
}

/**
 * User annotated link if there are annotations
 */
function defaultMsg() {
	if(!bm||!context){
		$('#txt-message').attr({value:''});
		return;
	}
	var z = this;
	var title = bm.title, description = bm.description, url = bm.url;
	
	//if there are annotations
	if (context && (context.pageComments.length > 0 || context.annotations.length > 0)) {
		D.AnnotatedLink.get(bm.url, 3, function(annotatedUrl) {
			shortenUrl(annotatedUrl);
		}, context);
	} else {
		shortenUrl(url);
	}
	
	function shortenUrl(url) {
		Tw.shortenUrl(url, function (shortUrl) {
			jTxtMsg.val(Tw.composeMessage(title, shortUrl, description));
			updateCountDown();
		});
	}
	updateCountDown();
}

function flickerLabels(){
	function a(callback){
		$('#box-twitter-connect').attr("hidden",true);
		setTimeout(function(){
			$('#box-twitter-connect').attr("hidden",false);
			if(callback)
				callback();
		},500);
	}
	a(function(){
		setTimeout(a,500);
	});
}

function updateCountDown() {
	var max = 140;
	var n = jTxtMsg[0].value.length;
	var left = Math.max(max - n, 0);
	$('#lbl-charsLeft').val(left);
	
	if (left <= 0) {
		//jTxtMsg.val(jTxtMsg.val().substring(0, max));
	}
	
	$('#box-charsCountDown').toggleClass('full', left <= 0);
}

function changeUser(){
	D.TwitterOAuth.reset();
	D.TwitterOAuth.changeUser();
	$('#box-twitter-change').attr("hidden",true);
	$('#box-twitter-signin').attr("hidden",false);
	$('#box-twitter-loading').attr("hidden",false);
	$('#box-twitter-connect').attr("value","Loading...");
}

function doOK() {
	if(!D.TwitterOAuth.checkAuthentication()){
		flickerLabels();
		return false;
	}
	
	var msg = jTxtMsg.val();
	if (msg.length > 140) {
		alert('Your message is too long!');
		return false;
	}
	
	//twitter this stopped working since firefox beta 5/4?
	//I thought it was because of https://bugzilla.mozilla.org/show_bug.cgi?id=422135
	//but it turns that the D.utils.fork is failing
	//fortunately "forking" is no longer needed in ff3. thanks to the background xhr improvement?
	//whatever, it seems to work now :) works in 3.0pre but not in beta5
	if (D.ff3up) {
		D.TwitterOAuth.API_statuses_update({status:msg});
	} else 
		D.utils.fork((function(D, msg) {return function() {D.TwitterOAuth.API_statuses_update({status:msg});};})(D, msg));	
}

function inviteFriends() {
//	if (confirm('This will replace your message with an invitation. Do you want to continue?')) {
//		jTxtMsg.val('Hi, please join my network on Diigo! ' + D.urls.getInviteFriens2URL());
//		updateCountDown();
//	}
}
