(function() {
	var D = window.diigo;
	var Utils = D.utils;
	var $ = D.$;
	
/////////////////////////////////////////////////////////////////////////////////

/**
 * 
 */
var MessageAlert = D.MessageAlert = {
	
	/**
	 * Are there any new messages since we last cleared the alert?
	 */
	refresh: function() {
		var z = this;
		
		//make sure we send a valid utc date string to server
		var lastAlertTime;
		try {
			lastAlertTime = new Date(D.prefs.val('messageAlert.lastAlertTime') || 0);
		} catch (e) {
			lastAlertTime = new Date(0);
		}
		
		D.WebAPI.checkForNewMessages(lastAlertTime.toUTCString(), function(data) {
			if(data==null)return;
			var j = $('#diigotb-tb-message');
			j.attr('alert', data.hasNew);
			j.attr('label', 'Message (#)'.replace('#', data.unreadCount || 0));
		});
	},
	
	/**
	 * Remember when we last cleared the alert
	 */
	clearAlert: function() {
		$('#diigotb-tb-message').attr('alert', false);
		D.prefs.val('messageAlert.lastAlertTime', new Date().toUTCString());
	}
};

/////////////////////////////////////////////////////////////////////////////////
})();