(function() {
	var D = window.diigo;
	var Utils = D.utils;

	var PageContext;
	D.registerRunLater(function () {
		PageContext = D["PageContext"];
	});

	
	var $ = D.$;
	
	var captureTemplate=D.captureTemplate={
		/*<div id="diigotb-editpanel">
			<div class="diigotb-bg">
				<div id="diigotb-rect" class="diigotb-btn enabled"><div></div></div>
				<div id="diigotb-round" class="diigotb-btn enabled"><div></div></div>
				<div id="diigotb-text" class="diigotb-btn enabled"><div></div></div>
				<div id="diigotb-arrow" class="diigotb-btn enabled"><div></div></div>
				<div class="diigotb-sep"><img src="chrome://diigotb/skin/spacer.gif" style="width:2px;height:22px"/></div>
				<div id="diigotb-undo" class="diigotb-btn"><div></div></div>
				<div id="diigotb-capture-save" class="diigotb-btn enabled"><div></div></div>
				<div id="diigotb-tip" class="diigotb-tip"></div>
			</div>
		</div>*/
		editPanel:'<div id="diigotb-editpanel"><div class="diigotb-bg"><div id="diigotb-rect" class="diigotb-btn enabled"><div title="Rectange"></div></div><div id="diigotb-round" class="diigotb-btn enabled"><div title="Ellipse"></div></div><div id="diigotb-text" class="diigotb-btn enabled"><div title="Text"></div></div><div id="diigotb-arrow" class="diigotb-btn enabled"><div title="Arrow"></div></div><div class="diigotb-sep"><img src="chrome://diigotb/skin/spacer.gif" style="width:2px;height:22px"/></div><div id="diigotb-undo" class="diigotb-btn"><div title="Undo"></div></div><div id="diigotb-capture-save" class="diigotb-btn enabled"><div title="Save to diigo"></div></div></div></div>',

		editTip:'<div id="diigotb-tip" class="diigotb-tip"></div>',
		/*		<div id="diigotb-topbar">
			<a id="diigotb-escLink">
				<span><strong>Esc</strong></span>
			</a>
			<span id="diigotb-msg">
			<img src="chrome://diigotb/skin/tip.png" alt="tips:">
			Left click in the grey area below and hold to select desired image capture area.
			<a style="display:none" href="#">Learn More &raquo;</a>
			</span>
		</div>*/
		headerTemplate:'<div id="diigotb-topbar"><a id="diigotb-escLink"><span><strong>Esc</strong></span></a><span id="diigotb-msg"><img src="chrome://diigotb/skin/tip.png" alt="tips:">Left click in the grey area below and hold to select desired image capture area.<a style="display:none" href="#">Learn More &raquo;</a></span></div>',

		/*      <div id="diigotb-upload-resizer" style="display:none;" >
		<div class="gleft gtop" style="cursor: nw-resize"
		   adjustHorz="1" adjustVert="1" />
		<div class="gtop ghor" style="cursor: n-resize"
		   adjustHorz="0" adjustVert="1" />
		<div class="gright gtop" style="cursor: ne-resize"
		   adjustHorz="-1" adjustVert="1" />
		<div class="gleft gver" style="cursor: w-resize"
		   adjustHorz="1" adjustVert="0" />
		<div class="gright gver" style="cursor: e-resize"
		   adjustHorz="-1" adjustVert="0" />
		<div class="gleft gbottom" style="cursor: sw-resize"
		   adjustHorz="1" adjustVert="-1" />
		<div class="gbottom ghor" style="cursor: s-resize"
		   adjustHorz="0" adjustVert="-1" />
		<div class="gright gbottom" style="cursor: se-resize"
		   adjustHorz="-1" adjustVert="-1" />
		</div>*/
		selectResizer:'<div id="diigotb-upload-resizer" style="display:none;" ><div class="gleft gtop" style="cursor: nw-resize" adjustHorz="1" adjustVert="1" /><div class="gtop ghor" style="cursor: n-resize" adjustHorz="0" adjustVert="1" /><div class="gright gtop" style="cursor: ne-resize" adjustHorz="-1" adjustVert="1" /><div class="gleft gver" style="cursor: w-resize" adjustHorz="1" adjustVert="0" /><div class="gright gver" style="cursor: e-resize" adjustHorz="-1" adjustVert="0" /><div class="gleft gbottom" style="cursor: sw-resize" adjustHorz="1" adjustVert="-1" /><div class="gbottom ghor" style="cursor: s-resize" adjustHorz="0" adjustVert="-1" /><div class="gright gbottom" style="cursor: se-resize" adjustHorz="-1" adjustVert="-1" /></div>',
	
		/*<div id="diigotb-text-area">
		    <div class="diigotb-text-input" style="position: absolute; visibility: hidden;"/>
			<textarea class="diigotb-text-input"/>
		</div>*/
		textInputArea:'<div id="diigotb-text-area"><div class="diigotb-text-input" style="position: absolute; visibility: hidden;"/><textarea class="diigotb-text-input"/></div>',
		/*<div id="diigotb-imagepanel">
			<div class="diigotb-btn enabled" title="Save this image to Diigo" id="diigotb-quick-save"></div>
		</div>
		*/
		imagePanel:'<div id="diigotb-imagepanel"><div class="diigotb-btn enabled" title="Save this image to Diigo" id="diigotb-quick-save"></div></div>',
		
		/*<div class="diigotb-imagetip">
			<div class="diigotb-imagebg">
				<span class="diigotb-imagetip-text"></span>
			</div>
		</div>*/
		imageTip:'<div class="diigotb-imagetip"><div class="diigotb-imagebg"><span class="diigotb-imagetip-text"></span></div></div>',

		/*
		 <div class="diigotb-notice-msg">
		    <div class="diigotb-notice-msg-rt">
		        <span class="diigotb-notice-img"/>
				<span class="diigotb-notice-text"></span>
				<span title="Close" class="diigotb-notice-close"/>
		    </div>
		</div>
		 * */
		pageMessage:'<div class="diigotb-notice-msg"><div class="diigotb-notice-msg-rt"><span class="diigotb-notice-img"/><span class="diigotb-notice-text"></span><span title="Close" class="diigotb-notice-close"/></div></div>',
		
		/*		<div id="diigotb-colorpanel">
			<div class="diigotb-cbg">
				<div id="currentArrow"></div>
				<div id="currentColor">
					<div class="capture-red"></div>
				</div>
				<div class="colorCell"><div class="capture-black"></div></div>
				<div class="colorCell"><div class="capture-gray"></div></div>
				<div class="colorCell"><div class="capture-red"></div></div>
				<div class="colorCell"><div class="capture-orange"></div></div>
				<div class="colorCell"><div class="capture-yellow"></div></div>
				<div class="colorCell"><div class="capture-green"></div></div>
				<div class="colorCell"><div class="capture-white"></div></div>
				<div class="colorCell"><div class="capture-light-gray"></div></div>
				<div class="colorCell"><div class="capture-cyan"></div></div>
				<div class="colorCell"><div class="capture-blue"></div></div>
				<div class="colorCell"><div class="capture-purple"></div></div>
				<div class="colorCell"><div class="capture-pink"></div></div>
			</div>
		</div>*/		
		colorpanelTemplate:'<div id="diigotb-colorpanel"><div class="diigotb-cbg"><div id="currentArrow"></div><div id="currentColor"><div class="capture-red"></div></div><div class="colorCell"><div class="capture-black"></div></div><div class="colorCell"><div class="capture-gray"></div></div><div class="colorCell"><div class="capture-red"></div></div><div class="colorCell"><div class="capture-orange"></div></div><div class="colorCell"><div class="capture-yellow"></div></div><div class="colorCell"><div class="capture-green"></div></div><div class="colorCell"><div class="capture-white"></div></div><div class="colorCell"><div class="capture-light-gray"></div></div><div class="colorCell"><div class="capture-cyan"></div></div><div class="colorCell"><div class="capture-blue"></div></div><div class="colorCell"><div class="capture-purple"></div></div><div class="colorCell"><div class="capture-pink"></div></div></div></div>'
	};

	D.captureMode={
		//captureItems:{},
		currentItem:null,	
		insertPos:null,
		
		onCaptureKeyDown: function(e){
			if(e.keyCode==27){//Esc
				D.captureMode.exitCaptureMode();
			}
		},
		onCaptureResize: function(e){
			var doc=e.data.pdoc;
			var item=D.captureMode.currentItem;
			if(item){
				item.scrollTop = Math.max(doc.documentElement.scrollTop, doc.body.scrollTop);
				item.scrollLeft = Math.max(doc.documentElement.scrollLeft, doc.body.scrollLeft);
				//item.offsetY = (31>item.scrollTop)?31-item.scrollTop:0;
			}

			D.captureMode.updateCapturebg(doc);
			D.captureMode.updateSelectedRect();
			Utils.canvas.setStyle(item.context,item.color,4);
		},
		onCaptureScroll: function(e){
			var doc=e.data.pdoc;
			var item=D.captureMode.currentItem;
			if(item){
				item.scrollTop = Math.max(doc.documentElement.scrollTop, doc.body.scrollTop);
				item.scrollLeft = Math.max(doc.documentElement.scrollLeft, doc.body.scrollLeft);
				//item.offsetY = (31>item.scrollTop)?31-item.scrollTop:0;
			}
			
			//D.captureMode.updateCapturebg(doc);
			//D.captureMode.updateSelectedRect();
			Utils.canvas.setStyle(item.context,item.color,4);
		},
		
		setCanvasSize: function(mCanvas, w, h)
		  {
			mCanvas.style.width = w + "px";
			mCanvas.style.height = h + "px";
			mCanvas.style.maxWidth = w + "px";
			mCanvas.style.maxHeight = h + "px";
			mCanvas.width = w;
			mCanvas.height = h;
		},	
		
		updateCapturebg: function(doc){
			coverElement = $("#diigotb-upload-cover");
			var coverRect={nleft:0,ntop:0,nWidth:0,nHeight:0};
			coverRect.nWidth=$(content).width();
			coverRect.nHeight=$(content).height();
			this.setCanvasSize(coverElement[0], coverRect.nWidth, coverRect.nHeight);
			
		    var canvascontext = coverElement[0].getContext("2d");
		    canvascontext.clearRect(0, 0, coverRect.nWidth, coverRect.nHeight);
		    
		    canvascontext.fillStyle = "rgba(102,102,102,0.5)";
		    canvascontext.fillRect(0, 0, coverRect.nWidth, coverRect.nHeight);		
		    
		    $("#diigotb-topbar").css({'width':coverRect.nWidth});
		},
		
		updateSelectedRect: function(){
			var item=D.captureMode.currentItem;
			var left=item.captureleft;
			var top=item.capturetop;
			var width=item.capturewidth;
			var height=item.captureheight;
						
			var selectElement=$("#diigotb-upload-select")
			.css({
				display: "inline",
				left: left + "px",
				top: top + "px",
				width: width + "px",
				height: height + "px"
				});
			D.captureMode.setCanvasSize(selectElement[0], width, height);
			
			$("#diigotb-upload-tip").
			css({
				left:left,
				top:top-25
			}).text('Dimensions: '+width+' x '+height);
			
			var resizer=$('#diigotb-upload-resizer').css({
				left:left-1,
				top:top-1,
				width:width+1,
				height:height+1
			});
			
			var selectBgElement=$("#diigotb-upload-cover");
			try{
			var canvascontext = selectBgElement[0].getContext("2d");
			canvascontext.clearRect(left, top-item.offsetY, width+1, height+1);
			
			canvascontext = selectElement[0].getContext("2d");
			canvascontext.clearRect(0, 0, width+1, height+1);
			
			item.operationList.length=0;
			item.bgImageUrl=null;
			if(item.editpanel){
				var undoBtn=item.editpanel.find('#diigotb-undo');
				undoBtn.removeClass('enabled');
			}
			}catch(e){
				throw(e);
			}
		},
		
		selectionResizeStart: function(event){
		    if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey)
		          return false;
		    if (event.button != 0)
		          return false;
		    var item=D.captureMode.currentItem;
			if(item.textInputing)
				return true;
			if(item.drawReady)
				return false;
			item.selectionBeginresize=true;
			item.resizeStartX=event.clientX;
			item.resizeStartY=event.clientY;
			var target=$(event.target);
			if(target.attr('id')=='diigotb-upload-resizer'){
				item.iMovingBox=true;
				target.css({cursor:'move'});
			}else{
				item.iResizingBox=true;
				item.mAdjustHorz = target.attr("adjustHorz");
				item.mAdjustVert = target.attr("adjustVert");
		        
		        var cursor = target.css('cursor');
		        target.css({cursor:cursor});
		        $("#diigotb-upload-cover").css({cursor:cursor});
			}
			D.captureMode.edit.hide();
			event.preventDefault();
			event.stopPropagation();
			return true;
			
		},
		selectionResizing: function(event){
		    if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey)
		          return false;
			var item=D.captureMode.currentItem;
			if(item.textInputing)
				return true;
			if(item.drawReady)
				return false;
			if(item.selectionBeginresize&&!item.beginDraw){
				var AdjustOffsetX = event.clientX - item.resizeStartX;
				var AdjustOffsetY = event.clientY - item.resizeStartY;
				var iResize=false;
				if(item.iMovingBox){
					item.captureleft+=AdjustOffsetX;
					item.capturetop+=AdjustOffsetY;
					iResize=true;
				}else if(item.iResizingBox){
			          if (1 == item.mAdjustHorz){
			        	  var tempWidth=item.capturewidth-AdjustOffsetX;
			        	  if(tempWidth>0){
			        		  item.captureleft += AdjustOffsetX;
			        		  item.capturewidth -= AdjustOffsetX;
			        		  iResize=true;
			        	  }
			          }else if(-1 == item.mAdjustHorz){
			        	  var tempWidth=item.capturewidth+AdjustOffsetX;
			        	  if(tempWidth>0){
			        		  item.capturewidth += AdjustOffsetX;
			        		  iResize=true;
			        	  }
			          }

			          if (1 == item.mAdjustVert){
			        	  var tempHeight=item.captureheight-AdjustOffsetY;
			        	  if(tempHeight>0){
			        		  item.capturetop += AdjustOffsetY;
			        		  item.captureheight -= AdjustOffsetY;
			        		  iResize=true;
			        	  }
			          }else if(-1 == item.mAdjustVert){
			        	  var tempHeight=item.captureheight+AdjustOffsetY;
			        	  if(tempHeight>0){
			        		  item.captureheight += AdjustOffsetY;
			        		  iResize=true;
			        	  }
			          }
				}
				if(item.captureleft<0)item.captureleft=0;
				
				if(iResize){
					item.resizeStartX=event.clientX;
					item.resizeStartY=event.clientY;
				}
				D.captureMode.updateCapturebg(event.data.pdoc);	
				D.captureMode.updateSelectedRect();
			}
			event.preventDefault();
			event.stopPropagation();
			return true;

		},		
		selectionResizeEnd:function(event){
			event.preventDefault();
			event.stopPropagation();
			var item=D.captureMode.currentItem;
			if(item.drawReady)
				return false;
			item.selectionBeginresize=false;
        	$("#diigotb-upload-cover").css({cursor:'crosshair'});
        	item.iResizingBox=false;
        	item.iMovingBox=false;
			D.captureMode.edit.show();
        	return true;
		},
		
		ClipStart: function(event){
		    if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey)
		          return false;
		    if (event.button != 0)
		          return false;
			var item=D.captureMode.currentItem;
			if(item.textInputing)
				return true;
			if(item.drawReady)
				return false;
			item.captureleft=event.clientX;
			item.capturetop=event.clientY;
			item.capturewidth=0;
			item.captureheight=0;
			D.captureMode.updateCapturebg(event.data.pdoc);
			
			if($("#diigotb-upload-select").css('display')!='none'){
				return true;
			}
			item.beginDraw=true;

			$("#diigotb-upload-select")
			.css({
				left: item.captureleft,
				width: 0,
				height: 0,
				'z-index': 1100000,
				top: item.capturetop}).show();
			
			
			var tipElement = $("#diigotb-upload-tip");
			if(tipElement.size()<=0){
				tipElement = $('<div id="diigotb-upload-tip"/>')
				.prependTo(D.captureMode.insertPos)
				.bind('mousemove',{pdoc:event.data.pdoc},D.captureMode.selectionResizing)
				.show();
			}else{
				tipElement.show();
			}
			tipElement.text('Dimensions: 0 x 0')
			.css({
				left:item.captureleft,
				top:item.capturetop-25});

		    D.captureMode.edit.hide();
			
			return true;
		},
		
		Clipping: function(event){
		    if (event.ctrlKey || event.shiftKey || event.altKey || event.metaKey)
		          return false;
			var item=D.captureMode.currentItem;
			if(item.textInputing)
				return true;
			if(item.drawReady)
				return false;
			if(item.beginDraw){
			    var mouseX = event.clientX;
			    var mouseY = event.clientY;
			    
			    var left = mouseX < item.captureleft ? mouseX : item.captureleft;
			    var top = mouseY < item.capturetop ? mouseY : item.capturetop;

			    var width = Math.abs(mouseX - item.captureleft);
			    var height = Math.abs(mouseY - item.capturetop);
			    
				item.captureleft=left;
				item.capturetop=top;
				item.capturewidth=width;
				item.captureheight=height;
				

				D.captureMode.updateCapturebg(event.data.pdoc);	
				D.captureMode.updateSelectedRect();

			}else if(item.selectionBeginresize){
				D.captureMode.selectionResizing(event);
			}
			event.preventDefault();
			event.stopPropagation();
			return true;
		},
		
		ClipEnd: function(event){
			event.preventDefault();
			event.stopPropagation();
			var item=D.captureMode.currentItem;
			if(item.operation!=3)
				D.captureMode.edit.onDrawEnd(item);
			if(item.drawReady)
				return false;
			
			if(item.beginDraw){
				item.beginDraw=false;
				var resizer=$('#diigotb-upload-resizer');
				if(resizer.size()<=0){
					resizer = $(captureTemplate.selectResizer)
					.prependTo(D.captureMode.insertPos)
					.bind('mousemove',{pdoc:event.data.pdoc},D.captureMode.selectionResizing)
					.mousedown(D.captureMode.selectionResizeStart)
					.mouseup(D.captureMode.selectionResizeEnd)
					.show();
				}else{
					resizer.show();
				}
				resizer.css({
					position:'fixed',
					left:item.captureleft-1,
					top:item.capturetop-1,
					width:item.capturewidth+2,
					height:item.captureheight+2
					});
				D.captureMode.edit.show();
			}else if(item.selectionBeginresize){
				D.captureMode.selectionResizeEnd(event);
			}
			
			if(item.capturewidth*item.captureheight<=10){
			    $("#diigotb-upload-select").hide();
			    $("#diigotb-upload-tip").hide();
			    $('#diigotb-upload-resizer').hide();
			    D.captureMode.edit.hide();
			}

			return true;
		},
		mouseHijack: function(event){
			item=event.target;
			if((item.className&&item.className.indexOf("diigotb")>=0)
					||(item.id&&item.id.indexOf("diigotb")>=0)){
				
			}else{
				event.stopPropagation();
				event.preventDefault();	
			}
		},
		stopEvent: function(e){
			  e.stopPropagation(); 
			  e.preventDefault();
			  return false;
		},
		
		enterCaptureMode:function(doc){
			$=doc.__diigo.$;
			this.insertPos = doc.body.parentNode;
			
			z=this;
			var coverElement = $("#diigotb-upload-cover");
			if(coverElement.size()<=0){
				coverElement = $('<canvas id="diigotb-upload-cover"/>')
				.prependTo(z.insertPos)
				.show();
			}else{
				coverElement.show();
			}

			coverElement.css({
				cursor:'crosshair'
			});
			PageContext.addCSSFile(doc);
					    
			$(z.insertPos).addClass('diigotb-body');
			
			var uploadHeader = $("#diigotb-topbar");
			if(uploadHeader.size()<=0){
				uploadHeader=$(captureTemplate.headerTemplate).prependTo(z.insertPos);
				uploadHeader.find("#diigotb-escLink").click(function(){
					D.captureMode.exitCaptureMode();
				});
			}else{
				uploadHeader.show();
			}

			var item=D.captureMode.currentItem=D.getCurrentContext().captureItem;			
			item.scrollTop = Math.max(doc.documentElement.scrollTop, doc.body.scrollTop);
			item.scrollLeft = Math.max(doc.documentElement.scrollLeft, doc.body.scrollLeft);
			//item.offsetY = (31>item.scrollTop)?31-item.scrollTop:0;
			item.urlId=D.getCurrentContext().bookmark.urlId;
			D.getCurrentContext().bookmark.image=null;
			this.updateCapturebg(doc);
		
			item.isCaptureMode=true;
			item.drawReady=false;
			
			var selectElement = $("#diigotb-upload-select");
			if(selectElement.size()<=0){
				selectElement = $('<canvas id="diigotb-upload-select"/>').prependTo(z.insertPos).hide();
			}
			
			$("#diigotb-upload-cover").bind('mousedown',{pdoc:doc},this.ClipStart)
			.bind('mousemove',{pdoc:doc},this.Clipping)
			$(content).bind('resize',{pdoc:doc},this.onCaptureResize);
			$(content).bind('scroll',{pdoc:doc},this.onCaptureScroll);
			$(content).bind('mouseup',{pdoc:doc},this.ClipEnd);
			$(content).bind('keydown',this.onCaptureKeyDown);
			$(doc).bind('DOMMouseScroll',this.stopEvent);
			
			//.bind('mouseover',this.mouseHijack)
			$("*").bind('mousemove',this.mouseHijack)
			.bind('mouseout',this.mouseHijack)
			//.bind('mousedown',this.mouseHijack)
			//.bind('mouseup',this.mouseHijack);
		},
		
		updateEventHandler: function(doc){
			$=doc.__diigo.$;
		},
		
		exitCaptureMode:function(){
			$=content.document.__diigo.$;
			
			$(this.insertPos)
			.removeClass('diigotb-body');
			$("#diigotb-topbar").hide();
			var canvasSelect=$("#diigotb-upload-select").hide();
			$('#diigotb-upload-resizer')
			//.unbind('mousemove',this.selectionResizing)
			.hide();
			$('#diigotb-upload-tip').hide();
			var canvasCover=$("#diigotb-upload-cover")
			//.unbind('mousedown',this.ClipStart)
			//.unbind('mousemove',this.Clipping)
			.hide();
			
			$('#screenshot').attr('checked',false);
			
			if(canvasCover[0]){
			    var canvascontext = canvasCover[0].getContext("2d");
			    canvascontext.clearRect(0, 0, canvasCover.width(), canvasCover.height());	
			}
			if(canvasSelect[0]){
			    var canvascontext = canvasSelect[0].getContext("2d");
			    canvascontext.clearRect(0, 0, canvasSelect.width(), canvasSelect.height());	
			}
			var item=D.captureMode.currentItem;
			item.captureleft=0;
			item.capturetop=0;
			item.capturewidth=0;
			item.captureheight=0;
			item.isCaptureMode=false;
			item.beginDraw=false;
			D.captureMode.edit.hide();
			
			$(content).unbind('keydown',this.onCaptureKeyDown);
			$(content).unbind('scroll',this.onCaptureScroll);
			$(content).unbind('mouseup',this.ClipEnd);
			$(content).unbind('resize',this.onCaptureResize);
			$(content.document).unbind('DOMMouseScroll',this.stopEvent);
			document.getElementById('diigotb-tb-capture').checked=false;
			
			//.unbind('mouseover',this.mouseHijack)
			$("*").unbind('mousemove',this.mouseHijack)
			.unbind('mouseout',this.mouseHijack);
			//.unbind('mousedown',this.mouseHijack)
			//.unbind('mouseup',this.mouseHijack);
			
			D.captureMode.currentItem=null;
		},
		
		edit:{
			init:function(){
				var item=D.captureMode.currentItem;
				item.editpanel=$('#diigotb-editpanel');
				if(item.editpanel.size()<=0){
					item.editpanel = $(captureTemplate.editPanel)
					.prependTo(D.captureMode.insertPos)
					.css({width:160})
					item.editpanel.find('.diigotb-bg').css({width:148});
				}
				item.colorpanel=$('#diigotb-colorpanel');
				if(item.colorpanel.size()<=0){
					item.colorpanel = $(captureTemplate.colorpanelTemplate)
					.prependTo(D.captureMode.insertPos).hide();
				}
				var z=this;
				item.editTip=$('#diigotb-tip');
				if(item.editTip.size()<=0){
					item.editTip=$(captureTemplate.editTip).prependTo(D.captureMode.insertPos);
				}
				
				var showTimer=true;
				var _tipTime;
				item.editpanel.find('.diigotb-btn div').mouseover(function(){
					var ele=$(this);
					var tip=item.editTip;
					function a(target){
						var szt=target.attr('title');
						tip.text(szt).css({left:target.offset().left+5,top:target.offset().top+25}).show();
						shown=true;
					}
					var shown=false;
					_tipTime=setInterval(function(){
						if(showTimer){
							if(!shown){
								a(ele);
							}else{
								item.editTip.hide().text('');
							}
							clearInterval(_tipTime);
							_tipTime=null;
						}else{
							showTimer=true;
						}
					},500);
				}).mouseout(function(){
					var tip=item.editTip.hide().text('');
					showTimer=false;
					clearInterval(_tipTime);
					_tipTime=null;
				}).mousemove(function(){
					var tip=item.editTip.hide().text('');
					showTimer=false;
				});
				
				item.editpanel.find('.diigotb-btn').click(function(event){
					var benabled=$(event.target).hasClass('enabled')
					var target=benabled?$(event.target):$(event.target).parent();
					if(target.hasClass('enabled')){
						
						if(target.attr('id')=='diigotb-rect'){
							z.onClickRect(event,target)
						}else if(target.attr('id')=='diigotb-round'){
							z.onClickRound(event,target)
						}else if(target.attr('id')=='diigotb-text'){
							z.onClickText(event,target)
						}else if(target.attr('id')=='diigotb-arrow'){
							z.onClickArrow(event,target)
						}else if(target.attr('id')=='diigotb-undo'){
							z.onClickUndo(event)
						}else if(target.attr('id')=='diigotb-capture-save'){
							if(item.textInputing){
								var input=item.inputPanel.find('textarea.diigotb-text-input')[0];
								input.blur();
							}
							setTimeout(function(){
								z.onClickSave(event)
							},100);
						}
					}
				});
				item.colorpanel.find('.colorCell>div')
				.mousedown(function(event){
					var target=$(event.target);
					var btn=target.parent();
					z.onUpdateColorActiveBtn(btn);
					item.color=target.attr('class');
					item.colorpanel.find('#currentColor>div').attr({'class':item.color});
					Utils.canvas.setStyle(item.context,item.color,4,'round');
					if(item.textInputing){
						$('textarea.diigotb-text-input').css({
							color:Utils.canvas.rgbColor[item.color]
						});
					}
					return false;
				});
			},
			onClickRect:function(event,btn){
				D.captureMode.currentItem.operation=1;
				this.showColorPenal(28);
				D.captureMode.currentItem.currentBtnX=28;
				this.onUpdateActiveBtn(btn);
				this.onreadytoDraw();
			},
			onClickRound:function(event,btn){
				D.captureMode.currentItem.operation=2;
				this.showColorPenal(52);
				D.captureMode.currentItem.currentBtnX=52;
				this.onUpdateActiveBtn(btn);
				this.onreadytoDraw();
			},
			onClickText:function(event,btn){
				D.captureMode.currentItem.operation=3;
				this.showColorPenal(75);
				D.captureMode.currentItem.currentBtnX=75;
				this.onUpdateActiveBtn(btn);
				this.onreadytoDraw();
			},
			onClickArrow:function(event,btn){
				D.captureMode.currentItem.operation=4;
				this.showColorPenal(100);
				D.captureMode.currentItem.currentBtnX=100;
				this.onUpdateActiveBtn(btn);
				this.onreadytoDraw();
			},
			onClickUndo:function(event){
				var item=D.captureMode.currentItem;
				item.operation=5;
				this.hideColorPenal()
				this.onUpdateActiveBtn($([]));
				item.operationList.pop();
				item.bgImageUrl=null,
				Utils.canvas.reDrawOper(item.context,
						$('#diigotb-upload-cover')[0].getContext('2d'),
						item.offsetY,
						item.operationList,
						item.captureleft,
						item.capturetop,
						item.capturewidth,
						item.captureheight
						);
				$('#diigotb-upload-select').css('cursor','default');
				var obj=Utils.canvas.saveTempFile(document.getElementById("diigo-canvas"),
						content,
						item.captureleft+item.scrollLeft,
						item.capturetop+item.scrollTop,
						item.capturewidth,
						item.captureheight);
				item.bgImageUrl=obj.url;
				Utils.canvas.drawBgImage($('#diigotb-upload-cover')[0].getContext('2d'),
						item.bgImageUrl,
						item.captureleft,
						item.capturetop-item.offsetY);
				
				if(item.editpanel){
					var undoBtn=item.editpanel.find('#diigotb-undo');
					if(item.operationList.length<=0){
						undoBtn.removeClass('enabled');
						//undoBtn.removeClass('actived');
					}
				}
			},
			onClickSave:function(event){
				try{
				var item=D.captureMode.currentItem;

				this.onUpdateActiveBtn($([]));
				item.operation=6;
				this.hide();
				this.hideColorPenal();
				$("#diigotb-topbar").hide();
			
				var obj=Utils.canvas.saveTempFile(document.getElementById("diigo-canvas"),
						content,
						item.captureleft+item.scrollLeft,
						item.capturetop+item.scrollTop,
						item.capturewidth,
						item.captureheight);
				item.bgImageUrl=obj.url;
				
				var name=Utils.string.md53(obj.url);
				D.upload.savefileLocal(name, obj);
				
				var c=D.getCurrentContext();
				
				D.PageMessage.reset();
				D.PageMessage.scheduleShow(3);
				bm=c.bookmark;
				bm.image_title="";
				bm.image_description="";
				bm.name=name;
				if(!bm.saved){
					bm.mode=D.prefs.val('bookmark.privateByDefault') ? D.PRIVACY_MODE_PRIVATE : D.PRIVACY_MODE_PUBLIC;
					bm.unread=D.prefs.val('bookmark.quickSaveUnread');
					
					var quickSaveTags = D.parseTags(D.prefs.val('bookmark.quickSaveTag') || '');
					bm.tags=quickSaveTags;
				}
				bm.fileUploaded=true;
				
				D.WebAPI.uploadImage(bm,
						"capture",
						false,
						obj.url,
						{left:item.captureleft,top:item.capturetop},
						"png",
						"",
						context,
						function(data,ct,code){
							var _timer=10000;
							if(code==1){
								D.PageMessage.url=data.url.replace('DIIGO_FILE_HOME',D.urls.getDiigoURL());
								D.PageMessage.scheduleShow(0);
								_timer=60000;
							}else{
								D.PageMessage.scheduleShow(1);
							}
							setTimeout(function(){
								D.PageMessage.hide();
							},_timer);
						});	

				//D.handle('bookmark', false, c);
				
				//D.upload.savefileLocal(item.urlId+'.png',obj,'Desk');
				D.captureMode.exitCaptureMode();
				}catch(e){
					throw(e);
				}
				
			},
			getTextSize: function(text, el){
				
				innerText=text.replace(/\n/g,'<br/>');
				el.innerHTML = innerText.replace(/\s/g, '&nbsp;');
				var off={w:el.offsetWidth,h:el.offsetHeight};
				if(el.offsetWidth > 500){
					off.w=500;
				}
				if(text[text.length-1]=='\n')
					off.h+=22;
//				if(el.offsetHeight > 100){
//					off.h=100;
//				}

				return off;
			},
			
			onInsertInputArea:function(event){
				var item=D.captureMode.currentItem;
				if(item.textInputing){
					return true;
				}
				//item.inputPanel=$('#diigotb-text-area');
				if(item.inputPanel==null||item.inputPanel.size()<=0){
					item.inputPanel = $(captureTemplate.textInputArea)
					.prependTo(D.captureMode.insertPos);
				}
				item.textInputing=true;
				var z=this;
				var stopW=false,stopH=false;
				z.cX=event.clientX,z.cY=event.clientY-14;
				item.inputPanel.css({
					left:z.cX,
					top:z.cY
				})
				.show()
				.find('textarea.diigotb-text-input')
				.css({
					width:15,
					height:24,
					"border-width":'2px',
					color:Utils.canvas.rgbColor[item.color]
				})
				.val('')
				.bind('keydown',function(e){
					if((e.keyCode>=33&&e.keyCode<=40)||
							e.keyCode==8||
							e.keyCode==46
							){
						return true;
					}
					var text=$(this).val()//attr('htmlAttr');
					var el=item.inputPanel.find('div.diigotb-text-input');//.text(text);
					var off=z.getTextSize(text+String.fromCharCode(e.keyCode), el[0]);
					var offset=$(this).offset();

					if(offset.left+(off.w - item.scrollLeft)+20>item.captureleft+item.capturewidth){
						stopW=true;
					}else if(offset.top+(off.h - item.scrollTop)>item.capturetop+item.captureheight+5){
						stopH=true;
					}else{
						stopW=false;
						stopH=false;						
					}
					
					if(e.keyCode!=13&&stopW){
						e.preventDefault();
						return false;
					}else if(stopH){
						e.preventDefault();
						return false;
					}
				})
				.bind('input',function(e){
					var text=$(this).val()//attr('htmlAttr');
					var el=item.inputPanel.find('div.diigotb-text-input');//.text(text);
					var off=z.getTextSize(text, el[0]);
					item.textInputing=true;
					$(this).css({
						width:off.w+20,
						height:off.h
					});
				})
				.blur(function(event){
					if(item.textInputing){
						var text=$(this).val();
						if(text.length>0){
							item.operationList.push(Utils.canvas.beginDraw(item.context,3,z.cX-item.captureleft,z.cY-item.capturetop,0,0,text));
						}
						item.inputPanel.hide();
						z.onDrawEnd(item);
						item.textInputing=false;
						stopW=false;
						stopH=false;
					}
				});
				setTimeout(function(){
					$('textarea.diigotb-text-input')[0].focus();
				},500);
			},
			
			onDrawEnd:function(item){
				if(!item.drawStart&&!item.textInputing)
					return true;
				if(item.operation!=5){
					this.hide();
					this.hideColorPenal()
					var obj=Utils.canvas.saveTempFile(document.getElementById("diigo-canvas"),
							content,
							item.captureleft+item.scrollLeft,
							item.capturetop+item.scrollTop,
							item.capturewidth,
							item.captureheight);
					this.show(true);
					this.showColorPenal(item.currentBtnX);
	
					Utils.canvas.drawBgImage($('#diigotb-upload-cover')[0].getContext('2d'),
							obj.url,
							item.captureleft,
							item.capturetop-item.offsetY);
					if(item.editpanel){
						var undoBtn=item.editpanel.find('#diigotb-undo');
						if(item.operationList.length>0){
							undoBtn.addClass('enabled');
						}
					}
					
					item.bgImageUrl=obj.url;
						
					//if(item.operation==6){
					//D.upload.savefileLocal(item.urlId+'.png',obj);
					//}
					
				}
				
				item.drawStart=false;
				
			},
			onreadytoDraw:function(){
				$('#diigotb-upload-resizer')
				.hide();
				var item=D.captureMode.currentItem;
				item.drawReady=true;
				var z=this;
				var background=$('#diigotb-upload-cover').css({
					cursor:'default'
				});
				var restoreImage=false;
				var select=$('#diigotb-upload-select').css({
					cursor:item.operation==3?'text':'crosshair',
					'z-index':'11000003'
				}).mousedown(function(e){
					if(restoreImage)
						return false;
					item.startX=e.clientX-item.captureleft;
					item.startY=e.clientY-item.capturetop;
					if(item.operation!=3){
						item.drawStart=true;
					}else{
						return z.onInsertInputArea(e);
					}
					return true;
				}).mousemove(function(e){
					if(restoreImage)
						return false;
					if(item.drawStart&&item.operation!=3){
						if(item.bgImageUrl)
							Utils.canvas.drawBgImage(background[0].getContext('2d'),
									item.bgImageUrl,
									item.captureleft,
									item.capturetop-item.offsetY);
						
						item.context.clearRect(0,0,item.capturewidth,item.captureheight); 
						
						item.endX=e.clientX-item.captureleft;//-item.startX;
						item.endY=e.clientY-item.capturetop;//-item.startY;
						item.newObj=Utils.canvas.beginDraw(item.context,item.operation,item.startX,item.startY,item.endX,item.endY);
						//if(item.bgImageUrl==null)
						
					}
				}).mouseup(function(e){
					restoreImage=true;
					if(item.drawStart&&item.operation!=3){
						item.bgImageUrl="";
						if(item.newObj){
							item.operationList.push(item.newObj);
							item.newObj=null;
						}
						z.onDrawEnd(item);
					}

					setTimeout(function(){
						restoreImage=false;
					},100);
					//alert(item.bgImageUrl);
				});
				item.context=$('#diigotb-upload-select')[0].getContext('2d'); 
				Utils.canvas.setStyle(item.context,item.color,4,'round');
			},
			onUpdateActiveBtn:function(btn){
				var item=D.captureMode.currentItem;
				item.editpanel.find('.diigotb-btn').removeClass('actived');
				btn.addClass('actived');
			},
			onUpdateColorActiveBtn:function(btn){
				var item=D.captureMode.currentItem;
				item.colorpanel.find('.colorCell').removeClass('actived');
				btn.addClass('actived');
			},
			onUpdateUndoBtn:function(){
				//item.editpanel.find('.diigotb-btn')
			},
			showColorPenal:function(left){
				var item=D.captureMode.currentItem;
				var panelLeft=item.captureleft+item.capturewidth-item.colorpanel.width();
				var panelTop=item.capturetop+item.captureheight+item.editpanel.height()+20;
				var istop=false;
				//alert(panelTop+35+" : "+$(content).height());
				if(panelTop+35>$(content).height()){
					panelTop=item.editTop-item.colorpanel.height()-5;
					istop=true;
				}
				item.colorpanel.css({
					left:panelLeft,
					top:panelTop
				}).show()
				.find('#currentArrow').css({
					left:left
				})
				.toggleClass('_istop',istop);
			},
			hideColorPenal:function(){
				var item=D.captureMode.currentItem;
				item.colorpanel.hide();
			},
			hide:function(){
				var item=D.captureMode.currentItem;
				if(item.editpanel)
					item.editpanel.hide();
				if(item.colorpanel)
					item.colorpanel.hide();
				$('#diigotb-text-area').hide();
				$('._diigoaddedText').hide();
			},
			show:function(update){
				var item=D.captureMode.currentItem;
				if(!item.editpanel){
					this.init();
				}
				
				var panelLeft=item.captureleft+item.capturewidth-item.editpanel.width();
				var panelTop=item.capturetop+item.captureheight+10;
				item.showOntop=false;
				if(panelTop+25>$(content).height()){
					if(item.capturetop>31+item.editpanel.height()){
						panelTop=item.capturetop-5-item.editpanel.height();	
						item.showOntop=true;
					}else{
						panelTop=panelTop-10-item.editpanel.height();					
					}
				}
				
				item.editpanel.css({
					left:panelLeft,
					top:panelTop
				}).show();
				item.editLeft=panelLeft;
				item.editTop=panelTop;
				if(!update)
					this.onUpdateActiveBtn($([]));
				
				item.rect.left=item.captureleft;
				item.rect.top=item.capturetop;
				item.rect.right=item.captureleft+item.capturewidth;
				item.rect.bottom=item.capturetop+item.captureheight;
			}
		}
		
	};
		
	D.upload={
		_uploadItem: {},
		
		capturePng: function (local,bm,callback,cut) {
			try{
				var ct=null;
			if(bm.context)
				ct=bm.context.win;
			if(!ct)
				ct=content;
			var w = ct.innerWidth + ct.scrollMaxX - 17;
			var h = ct.innerHeight + ct.scrollMaxY;
			if (w > 2000) w = 2000;
			if (h > 20000&&cut) h = 20000;
			
			var canvasW = w;
			var scale = canvasW/w;
			var canvasH = Math.round(h*scale);

			//if(D.ff3up)
			var canvas = document.getElementById('diigo-canvas');//$("#diigo-canvas")[0];
			//else
			//	canvas = $("canvas#diigo-canvas")[0];
			canvas.style.width = canvasW+"px";
			canvas.style.height = canvasH+"px";
			canvas.width = canvasW;
			canvas.height = canvasH;
			var ctx = canvas.getContext("2d");
			ctx.clearRect(0, 0, canvasW, canvasH);
			ctx.save();
			ctx.scale(canvasW/w, canvasH/h);

			ctx.drawWindow(ct, 0, 0, w, h, "rgb(255,255,255)");
			ctx.restore();
			var dataUrl = canvas.toDataURL("image/png");
		          		
			var nsIoService = Components.classes["@mozilla.org/network/io-service;1"].
								getService(Components.interfaces.nsIIOService);
			var channel = nsIoService.newChannelFromURI(nsIoService.newURI(dataUrl, null, null));
			var channsteam = channel.open();
			
			var binaryInputStream = Components.classes["@mozilla.org/binaryinputstream;1"].
			createInstance(Components.interfaces.nsIBinaryInputStream);
			binaryInputStream.setInputStream(channsteam);
			
			var numBytes = binaryInputStream.available();
			if(numBytes>10455040){
				if(!cut){
					return this.capturePng(local,bm,callback,true);
				}else if(callback){
					callback({v:"",n:-1});
				}
				return false;
			}
			//if(D.ff3up||local){//
				var bytes = binaryInputStream.readBytes(numBytes);				
				if(callback)
					callback({v:bytes,n:numBytes});
			/*}else{
				if(callback)
					callback({v:binaryInputStream,n:numBytes});
			}*/
			}catch(e){
				if(callback)
					callback({v:"",n:0});
				throw(e);
			}
			return true;
		},
		
		capturePngRect: function (win,left,top,width,height) {
			try{
			var w = width;
			var h = height;
			if (w > 20000) w = 20000;
			
			var canvasW = w;
			var canvasH = h;
			var canvas = document.getElementById('diigo-canvas');
			//if(D.ff3up)
			//	canvas = $("#diigo-canvas")[0];
			//else
			//	canvas = $("canvas#diigo-canvas")[0];
			canvas.style.width = canvasW+"px";
			canvas.style.height = canvasH+"px";
			canvas.width = canvasW;
			canvas.height = canvasH;
			var ctx = canvas.getContext("2d");
			ctx.clearRect(0, 0, w, h);
			ctx.save();
			ctx.scale(1, 1);
			ctx.drawWindow(win, left, top, w, h, "rgb(255,255,255)");
			ctx.restore();
			var dataUrl = canvas.toDataURL("image/png");
		          		
			var nsIoService = Components.classes["@mozilla.org/network/io-service;1"].
								getService(Components.interfaces.nsIIOService);
			var channel = nsIoService.newChannelFromURI(nsIoService.newURI(dataUrl, null, null));
			var binaryInputStream = Components.classes["@mozilla.org/binaryinputstream;1"].
			createInstance(Components.interfaces.nsIBinaryInputStream);
			binaryInputStream.setInputStream(channel.open());
			//if(D.ff3up){
				var numBytes = binaryInputStream.available();
				var bytes = binaryInputStream.readBytes(numBytes);				
				return {v:bytes,n:numBytes};
			/*}else{
				var numBytes = binaryInputStream.available();
				return {v:binaryInputStream,n:numBytes};
			}*/
			}catch(e){
				throw(e);
			}
		},	
		getfilePath: function (aim){
			//return D.utils.PathIO.GetExtentionPath('{fc2b8f80-d9a5-4f51-8076-7c7ce3c67ee3}');
			if(!aim)aim='TmpD';
	        var file = Components.classes["@mozilla.org/file/directory_service;1"].
            			getService(Components.interfaces.nsIProperties).
            			get(aim, Components.interfaces.nsIFile);//TmpD
	        return file.path;
		},
		
		savefileLocal: function (name,object,p){
			var strPath="";
			try{
				if(object.n<=0)return;
	     	var writeFlag = 0x02; // write only
	        var createFlag = 0x08; // create
	        var truncateFlag = 0x20; // truncate
	        
	        var extPath = this.getfilePath(p);
	        var tempImg = D.utils.FileIO.open(extPath);
	        tempImg.appendRelativePath(name);
	        if (tempImg.exists() == false)
	        {
	        	tempImg.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
	        }

	        strPath=tempImg.path;
	        var fileOutputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].
				createInstance(Components.interfaces.nsIFileOutputStream);
			fileOutputStream.init(tempImg, writeFlag | createFlag | truncateFlag, 0666, null);	    
			if(typeof object.v == 'string')
				fileOutputStream.write(object.v, object.n);
			else
				fileOutputStream.writeFrom(object.v, object.n);

	        fileOutputStream.close()
	        
	        tempImg=null;
			}catch(e){
				throw(e);
			}
			return strPath;
	    },
	    CaptureImageFromUrl:function(url,callback){
				var ioserv = Components.classes["@mozilla.org/network/io-service;1"]
				             .getService(Components.interfaces.nsIIOService);
				
				var channel = ioserv.newChannelFromURI(ioserv.newURI(url, null, null));
				var stream = channel.open();
				
				var channelengh=20000;//channel.contentLength;
				var _intervalTime, interNo=0;
				var name=Utils.string.md53(url);
				
				function a(){
					try{
						var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
						.createInstance(Components.interfaces.nsIBinaryInputStream);
						bstream.setInputStream(stream);
						var object={};
						
						var numBytes = bstream.available();
						if(/https?:\/\//.test(url)){
							var size = 0,totalsize=0;
							var file_data=''; 
							while(size = bstream.available()) { 
							    file_data += bstream.readBytes(size); 
								totalsize += size;
							} 
							object={v:file_data,n:totalsize};
						}else{
							var bytes = bstream.readBytes(numBytes);		
							object={v:bytes,n:numBytes};
						}
						
						D.upload.savefileLocal(name, object);
						return true;
					}catch(e){
						throw(e);
						return false;
					}
				}
				
				_intervalTime=setInterval(function(){
					interNo++;
					try{
						if(!channel.isPending()){
							var re=a();
							if(re){
								callback(true);
								clearInterval(_intervalTime); 
								return;
							}
						}
						if(interNo>20){
							clearInterval(_intervalTime);
							callback(false);
						}
					}catch(e){
						clearInterval(_intervalTime);
						callback(false);
						throw(e);
					}
				},1000);
				return name;
	    },
	    
	    ReadfileByURL: function (URL,reStream){
			var nsIoService = Components.classes["@mozilla.org/network/io-service;1"].
			getService(Components.interfaces.nsIIOService);
			var channel = nsIoService.newChannelFromURI(nsIoService.newURI(URL, null, null));
			var binaryInputStream = Components.classes["@mozilla.org/binaryinputstream;1"].
			createInstance(Components.interfaces.nsIBinaryInputStream);
			binaryInputStream.setInputStream(channel.open());
			
			var numBytes = binaryInputStream.available();
			if(reStream){
				return {v:binaryInputStream,n:numBytes};
			}else{
				if(/https?:\/\//.test(URL)){
					var size = 0,totalsize=0;
					var file_data; 
					while(size = binaryInputStream.available()) { 
					    file_data += binaryInputStream.readBytes(size); 
						totalsize += size;
					} 
					return {v:file_data,n:totalsize};
				}
				var bytes = binaryInputStream.readBytes(numBytes);		
				return {v:bytes,n:numBytes};
				
			}
	    },

	    ReadfileLocal: function (name,local){
	    	try{
	        //var extPath = D.utils.PathIO.GetExtentionPath('{fc2b8f80-d9a5-4f51-8076-7c7ce3c67ee3}');

	        //var path=extPath + "\\temp\\"+name;
	        
	        try{
	        var extPath = this.getfilePath();
	        	
	        var f = Components.classes["@mozilla.org/file/local;1"]
	         		                  .createInstance(Components.interfaces.nsIFile);
	        f.initWithPath(extPath);
	        f.appendRelativePath(name);
			
	        var istream = Components.classes["@mozilla.org/network/file-input-stream;1"]           
	         		      .createInstance(Components.interfaces.nsIFileInputStream);
	         		// open for reading
	        istream.init(f, 0x01, 0444, 0);
	        }catch(e){return {v:"",n:0};}

	        f=null;
	    	if(/*D.ff3up||*/local){
		        return {v:istream,n:istream.available()};
	    	}else{
	        	var sstream = Components.classes["@mozilla.org/binaryinputstream;1"].
                	createInstance(Components.interfaces.nsIBinaryInputStream);
				sstream.setInputStream(istream); 
				
				var size = 0,totalsize=0;
				var file_data = ""; 
				while(size = sstream.available()) { 
				    file_data += sstream.readBytes(size); 
				    totalsize += size;
				} 
				
				return {v:file_data,n:totalsize};
	        }
	    	}catch(e){
	    		throw(e);
				return {v:"",n:0};
	    	}
	    },	    
	    RemovefileLocal: function (name){
	    	try{
	    	var extPath = this.getfilePath();
	    	
			var f = Components.classes["@mozilla.org/file/local;1"]
	         		                  .createInstance(Components.interfaces.nsIFile);
	        f.initWithPath(extPath);
	        f.appendRelativePath(name);

	        try{
	        if(f.exists())
	        	f.remove(true);
	        }catch(e){}
	        
    		}catch(e){throw(e);}
	    },
	    checkfileType: function (path,name){
	    	var file = Components.classes['@mozilla.org/file/local;1']
	    						.createInstance(Components.interfaces.nsIFile);
	    	file.initWithPath(path);
	    	file.appendRelativePath(name);
	    	var mimeService = Components.classes["@mozilla.org/mime;1"]  
	    	          .createInstance(Components.interfaces.nsIMIMEService);  
	    	var mimeType = mimeService.getTypeFromFile(file);
	    	return mimeType;
	    },
		capturePageSource: function (bm,local,func){
			try{
				var ioserv = Components.classes["@mozilla.org/network/io-service;1"]
				             .getService(Components.interfaces.nsIIOService);
				
				var channel = ioserv.newChannelFromURI(ioserv.newURI(bm.url, null, null));
				var stream = channel.open();
				
				var channelengh=20000;//channel.contentLength;
				var _intervalTime, interNo=0;
				
				function a(){
					try{
						var bstream = Components.classes["@mozilla.org/binaryinputstream;1"]
						.createInstance(Components.interfaces.nsIBinaryInputStream);
						bstream.setInputStream(stream);
						var object={};
						
						if(channel.contentType)
							bm.contentType=channel.contentType;
						if(channel.contentCharset)
							bm.charset=channel.contentCharset;

						//if(D.ff3up||local){//D.ff3up
							var size = 0,totalsize=0;
							var file_data = ""; 
							while(size = bstream.available()) { 
							    file_data += bstream.readBytes(size); 
							    totalsize += size;
							} 
							object = {v:file_data,n:totalsize};
						/*}else{
							object = {v:bstream,n:bstream.available()};
						}*/
						
						if(func)
							func(object);
						return true;
					}catch(e){
						//alert(e);
						return false;
					}
				}
				

				_intervalTime=setInterval(function(){
					interNo++;
					try{
						if(!channel.isPending()){
							var re=a();
							if(re){
								clearInterval(_intervalTime); 
								return;
							}
						}
						if(interNo>240){
							clearInterval(_intervalTime);
							D.uploadNetwork.callbackError(bm,null,'Upload failed due to the large file size or network problem.');
						}
					}catch(e){
						if(func)
							func({v:"",n:0});
						clearInterval(_intervalTime);
					}
				},5000)
			}catch(e){
				if(func)
					func({v:"",n:0});
				//throw(e);
			}
		},
		capturePageTxt2: function (bm,callback){
			try{
			var doc=bm.context.topDoc;
			function getText(node){
				var con="";
				children=node.childNodes;
				for(var i=0;i<children.length;i++){
					child=children[i];
					if(child&&(child.tagName=="script"||
							child.tagName=="style"||
							child.tagName=="SCRIPT"||
							child.tagName=="STYLE")){
						continue;
					}else{
						//alert(child.tagName+" : "+child.textContent);
						con+=child.textContent;
					}
				}
				return con;
			}
			
			var content=getText(doc.body);	
			content=content.replace(/[\f\n\r\t\v]+/g,"\r\n");
	
			if(callback){
				callback({v:content,n:content.length});
			}
			}catch(e){
				
				D.upload.capturePageTxt(bm.urlId,callback);
				//if(callback){
				//	callback({v:"",n:0});
				//}				
			}
		},

		capturePageTxt: function (urlId,callback){
			try{
		        var extPath = this.getfilePath();
		        
		        var f = Components.classes["@mozilla.org/file/local;1"]
			         		                  .createInstance(Components.interfaces.nsIFile);
		        f.initWithPath(extPath);
		        f.appendRelativePath(urlId+"-2");
		        var path="file:///"+f.path;
		        f=null;
				
				iDoc=document.getElementById("diigotb-pagesource");
				if(!iDoc){
					iDoc = document.createElement("iframe"); // iframe or browser
					iDoc.setAttribute("id", "diigotb-pagesource");
					iDoc.setAttribute("name", "diigotb-pagesource");
					iDoc.setAttribute("type", "content");
					
					iDoc.style.setProperty('min-height', "0px", 'important');
					iDoc.style.setProperty('height', "0px", 'important');
					document.getElementById("main-window").appendChild(iDoc);
				}

				if(iDoc.webNavigation){
					iDoc.webNavigation.allowAuth = true;
					iDoc.webNavigation.allowImages = false;
					iDoc.webNavigation.allowJavascript = false;
					iDoc.webNavigation.allowMetaRedirects = true;
					iDoc.webNavigation.allowPlugins = false;
					iDoc.webNavigation.allowSubframes = false;
				}else if(iDoc.docShell){
					iDoc.docShell.allowAuth = true;
					iDoc.docShell.allowImages = false;
					iDoc.docShell.allowJavascript = false;
					iDoc.docShell.allowMetaRedirects = true;
					iDoc.docShell.allowPlugins = false;
					iDoc.docShell.allowSubframes = false;				
				}
								
				function onloaded(event) { 
					try{

					var doc = event.originalTarget;
					var url = doc.location.href;
					
					if (doc.nodeName == "#document"&&url.indexOf(urlId)>=0){
						function getText(node){
								var con="";
								children=node.childNodes;
								for(var i=0;i<children.length;i++){
									child=children[i];
									if(child&&(child.tagName=="script"||
											child.tagName=="style"||
											child.tagName=="SCRIPT"||
											child.tagName=="STYLE")){
										continue;
									}else{
										//alert(child.tagName+" : "+child.textContent);
										con+=child.textContent;
									}
								}
								return con;

						}
						
						var content=getText(doc.body);	
						content=content.replace(/[\f\n\r\t\v]+/g,"\r\n");

						if(callback){
							callback({v:content,n:content.length});
						}
						
						iDoc.setAttribute("src", "about:blank");
						//var This=this;
						iDoc.removeEventListener("DOMContentLoaded",onloaded,true);
					}
					}catch(e){
						if(callback)
							callback({v:"",n:0});
					}
				}
				iDoc.addEventListener("DOMContentLoaded", onloaded, true);
				
				iDoc.setAttribute("src", path)

			}catch(e){
				if(callback)
					callback({v:"",n:0});
			}
		},		
		
		uploadPdfPage: function(bm,Doc,batchId,sendbinary){

		},
		uploadImagePage: function(bm,Doc,batchId,sendbinary){
		},
		uploadTxtTage: function(bm,Doc,batchId,sendbinary){
		},
		uploadNormalPage: function(bm,batchId,sendbinary){
			D.upload.capturePageTxt2(bm,function(object){
				D.uploadNetwork.sendTxtFile(bm.urlId,batchId,
					'text/plain',3,"utf-8",
					object,
					function(success,msg){
						if(!success){
							D.uploadNetwork.callbackError(bm,batchId,msg);
							return;
						}
						D.uploadNetwork.checkBatch(bm,batchId);
						
				},false);
			})		
		},	
		SaveTempFile: function(bm,callBack){
			try{
				function a(succ){
					if(succ){
						if(callBack)
							callBack(true);
					}
				}

				/*if(D.isNormalPage(bm)&&bm.context!=null){
					D.upload.capturePng(true,bm,function(object){
						D.upload.savefileLocal(bm.urlId+"-1",object);
						D.upload.capturePageSource(bm,true,function(object){
							D.upload.savefileLocal(bm.urlId+"-2",object);
							a(true);
						});
					});
				}else{*/
					D.upload.capturePageSource(bm,true,function(object){
						D.upload.savefileLocal(bm.urlId+"-2",object);
						a(true);
					});	
				//}
			}catch(e){
				if(callBack)
					callBack(false);
			}
		}
	};
	
	D.uploadNetwork={
		checkFiles:{},

		sendBinary: function(urlId,batchId,type,index,Charset,object,callback,isrepeat){
			try{		  
				var paramObj = {
						user_name: D.env.user,
						link_id: urlId,
						batch_id: batchId,
						upload_type: index,
						charset: Charset,
						md5: Utils.string.md52(D.upload.ReadfileLocal(urlId+"-"+index,true).v),
						type: type
					};
				  posturl=D.urls.getUploadURL()+D.utils.string.toQueryString(paramObj);
		
				  var req = new XMLHttpRequest();
				  var timesout=null;
				  req.onreadystatechange = function (aEvt) {  
					  if (req.readyState == 4) {  
						  if(timesout==null)return;
						  clearTimeout(timesout);
						  timesout=null;
						  if(req.status == 200)  
						  {
							  D.uploadNetwork.BackReadyState(req.responseText,
									  paramObj,object,
									  D.uploadNetwork.sendTxtFile,
									  callback,isrepeat);
						  }else{
							  if(callback)
								 callback(false);
						  }
					  }
				  }; 
				  req.open("POST", posturl);
				  req.setRequestHeader("Content-type", type );
				  req.setRequestHeader("Content-length", object.n);

				  req.send(object.v);//binaryInputStream.readBytes(binaryInputStream.available())

				  timesout=setTimeout(function(){
					  if(callback)
						  callback(false,'Upload failed due to the large file size or network problem.');
					  clearTimeout(timesout);
					  req.abort();
					  timesout=null;
				  },1200000);

			}catch(e){
				if(callback)
					  callback(false);
				throw(e);
			}
		},

		sendTxtFile: function(urlId,batchId,type,index,Charset,object,callback,isrepeat){
			try{
				var MD5="";
				if(index==3){
					MD5=Utils.string.md53(object.v)
					//alert(MD5);
				}else{
					MD5=Utils.string.md52(D.upload.ReadfileLocal(urlId+"-"+index,true).v)
				}

				var paramObj = {
							user_name: D.env.user,
							link_id: urlId,
							batch_id: batchId,
							upload_type: index,
							charset: Charset,   
							md5: MD5,
							type: type
						};
				  posturl=D.urls.getUploadURL()+D.utils.string.toQueryString(paramObj);

				  var reqTxt = new XMLHttpRequest();
				  var timesout=null;
				  //req.setRequestHeader("Content-length", object.n);
				  reqTxt.onreadystatechange = function (aEvt) { 
					  if (reqTxt.readyState == 4) {  
						  if(timesout==null)return;
						  clearTimeout(timesout);
						  timesout=null;
						  if(reqTxt.status == 200)  
						  {
							  D.uploadNetwork.BackReadyState(reqTxt.responseText,
									  paramObj,object,
									  D.uploadNetwork.sendTxtFile,
									  callback,isrepeat);
						  }else{
							  if(callback)
								 callback(false);
						  }
					  }
				  };
				  reqTxt.open("POST", posturl);
				  reqTxt.setRequestHeader("Content-type", type);
				  //req.setRequestHeader("Content-length", object.n);
				  
				  reqTxt.send(object.v);

				  timesout=setTimeout(function(){
					  if(callback)
						  callback(false,'Upload failed due to the large file size or network problem.');
					  clearTimeout(timesout);
					  reqTxt.abort();
					  timesout=null;
				  },1200000);
		
			}catch(e){
				if(callback)
					  callback(false);
				throw(e);
			}
		},

		BackReadyState: function(responseText,paramObj,object,repeatFunc,callback,isrepeat){
			try{
					var json = D.utils.json.parseJSON(responseText);
					if(json.code==1&&json.size>=object.n){

						files=D.uploadNetwork.checkFiles[json.batch_id];
						if(!files){
							files=[];
							D.uploadNetwork.checkFiles[json.batch_id]=files;
						}
						
						re=diigoUtil.array.find(files, function(s) {
							return s[0] == json.type && s[1] == json.size && s[2] == paramObj.md5;
						});
		    			if(re==null){
							var file=[];
							file.push(json.type);
							file.push(json.size);
							file.push(paramObj.md5);
							
							files.push(file);
							if(callback)
								callback(true);
		    			}
					}else if(isrepeat!=true){
						setTimeout(function(){
							repeatFunc(
								 paramObj.link_id,
								 paramObj.batch_id,
								 paramObj.type,
								 paramObj.upload_type,
								 paramObj.charset,
								 paramObj.upload_type==3?object:D.upload.ReadfileLocal(paramObj.link_id+"-"+paramObj.upload_type,true),
								 callback,
								 true);
						},50);
					}else{
						if(callback)
							callback(false,json.msg);
					}

			}catch(e){
				 if(callback)
						 callback(false);
			}
		},
		checkBatch: function(bm,batchId){
			var paramObj = {
					user_name: D.env.user,
					link_id: bm.urlId,
					batch_id: batchId
				};
			posturl=D.urls.getUploadCheckURL()+D.utils.string.toQueryString(paramObj);
	
			var req = new XMLHttpRequest();
			req.open("POST", posturl);
			req.setRequestHeader("Content-type", 'application/x-www-form-urlencoded');
			  //req.setRequestHeader("Content-length", object.n);
			req.onreadystatechange = function (aEvt) {  
				  if (req.readyState == 4) {  
					    var succ=false;
					    var msg="";
					    if(req.status == 200)  
					    {
					    	try{
					    	var json = D.utils.json.parseJSON(req.responseText);
					    	if(json.code==1&&batchId==json.batch_id){
					    		var resendfiles=[];
						    	var files=D.uploadNetwork.checkFiles[batchId];
					    		//alert(req.responseText+"\r\n"+D.utils.json.toJSON(files));
						    	for(var i=files.length-1;i>=0;i--){
						    		file=files[i];
						    		if(file){
						    			re=diigoUtil.array.find(json.files, function(s) {
											return s[0] == file[0] && s[1] == file[1] && s[2] == file[2];
										});
						    			if(!re){
						    				resendfiles.push(file);
						    			}
						    		}
						    	}
						    	if(resendfiles.length<=0){
						    		succ=true;
						    	}
					    	}else{
					    		msg=json.msg;
					    	}
					    	}catch(e){
					    	}
					    }
						if(!succ){
							D.uploadNetwork.callbackError(bm,batchId,msg);
						}else{
							D.uploadNetwork.callbackSucc(bm,batchId);
						}
						
				  }
			};

		  	req.send("");
		},
		allSucceed: function(succ,urlId,batchId,groups){
			var paramObj = {
					user_name: D.env.user,
					link_id: urlId,
					status: succ?1:0,
					groups: groups==null?[]:Utils.json.toJSON(groups),
					batch_id: batchId
				};
			D.uploadNetwork.checkFiles[batchId]=null;
			posturl=D.urls.getUploadSuccessURL()+D.utils.string.toQueryString(paramObj);
	
			var req = new XMLHttpRequest();
			req.open("POST", posturl);
			req.setRequestHeader("Content-type", 'application/x-www-form-urlencoded');
			  //req.setRequestHeader("Content-length", object.n);
			req.onreadystatechange = function (aEvt) {  
				//D.uploadNetwork.BackReadyState(req,paramObj,object,D.uploadNetwork.sendTxtFile,callback);
			}; 
	
		  	req.send("");
		},		
		MD5Check: function(bm,uploadType,callback){
			var paramObj = {
					user_name: D.env.user,
					link_id: bm.urlId,
					upload_type: uploadType,
					type: bm.contentType,
					groups: bm.toShareToGroups==null?[]:Utils.json.toJSON(bm.toShareToGroups),
					md5: Utils.string.md52(D.upload.ReadfileLocal(bm.urlId+"-2",true).v)
				};
			posturl=D.urls.getUploadMD5Check()+D.utils.string.toQueryString(paramObj);
	
			var req = new XMLHttpRequest();
			req.open("POST", posturl);
			req.setRequestHeader("Content-type", 'application/x-www-form-urlencoded');
			  //req.setRequestHeader("Content-length", object.n);
			req.onreadystatechange = function (aEvt) {  
				  if (req.readyState == 4) {  
					    if(req.status == 200)  
					    {
					    	try{
					    	//alert("MD5Check: \r\n"+posturl+"\r\n response:"+req.responseText);
					    	var json = D.utils.json.parseJSON(req.responseText);
					    	if(json.code==2){
					    		D.uploadNetwork.callbackSucc(bm,null);
					    	}else if(json.code==1){
								if(callback)
									  callback(true,json.batch_id);
					    	}else{
								if(callback)
									  callback(false,json.batch_id,json.msg);							
							}
					    	}catch(e){
					    		if(callback)
									callback(false,null);
					    		throw(e);
					    	}
						}else{
							if(callback)
								callback(false,null);
					    }
				  }
			}; 
	
		  	req.send("");
		},	
		callbackError: function(bm,batchId,errorMsg){

			D.env.capturedImageNo--;
			if(batchId&&batchId.length>0)
				D.uploadNetwork.allSucceed(false,bm.urlId,batchId,[]);
			D.notifyError(errorMsg&&errorMsg.length>0?errorMsg:D.strings.getString('upload.error'), 10000);
			bm.captured=false;
			bm.toShareToGroups = null;
			D.upload.RemovefileLocal(bm.urlId+"-2");
			D.upload.RemovefileLocal(bm.urlId+"-1");
		},
		callbackSucc: function(bm,batchId){
			D.env.capturedImageNo--;
			if(batchId&&batchId.length>0)
				D.uploadNetwork.allSucceed(true,bm.urlId,batchId,bm.toShareToGroups);
			bm.captured=false;
			bm.cached=2;
			bm.toShareToGroups = null;
			D.Sidebar.refresh('cached');
			D.upload.RemovefileLocal(bm.urlId+"-2");
			D.upload.RemovefileLocal(bm.urlId+"-1");
		}
	};
		
	function StreamListener(aCallbackFunc) {
		this.mCallbackFunc = aCallbackFunc;
	}

	
	StreamListener.prototype = {
		mStream: null,

		  // nsIStreamListener
		onStartRequest: function (aRequest, aContext) {
		    this.mStream = null;
		},

		onDataAvailable: function (aRequest, aContext, aStream, aSourceOffset, aLength) {
			try{
			if(this.mStream==null){
				this.mStream=aStream;
			}else if(this.mStream.appendStream){
				this.mStream.appendStream(aStream);
			}else{
				this.mStream+=aStream;
			}
			}catch(e){
				this.mCallbackFunc(null);
			}
		},

		onStopRequest: function (aRequest, aContext, aStatus) {
			try{
		    if (Components.isSuccessCode(aStatus)) {
		      // request was successfull
		      this.mCallbackFunc({v:this.mStream,n:this.mStream.available()});
		    } else {
		      // request failed
		      this.mCallbackFunc(null);
		    }

		    //gChannel = null;
			}catch(e){
				this.mCallbackFunc(null);
			}
		},

		  // nsIChannelEventSink
		onChannelRedirect: function (aOldChannel, aNewChannel, aFlags) {
		    // if redirecting, store the new channel
		    //gChannel = aNewChannel;
		},

		  // nsIInterfaceRequestor
		getInterface: function (aIID) {
		    try {
		      return this.QueryInterface(aIID);
		    } catch (e) {
		      throw Components.results.NS_NOINTERFACE;
		    }
		},

		  // nsIProgressEventSink (not implementing will cause annoying exceptions)
		onProgress : function (aRequest, aContext, aProgress, aProgressMax) { },
		onStatus : function (aRequest, aContext, aStatus, aStatusArg) { },

		  // nsIHttpEventSink (not implementing will cause annoying exceptions)
		onRedirect : function (aOldChannel, aNewChannel) { },

		  // we are faking an XPCOM interface, so we need to implement QI
		QueryInterface : function(aIID) {
		    if (aIID.equals(Components.interfaces.nsISupports) ||
		        aIID.equals(Components.interfaces.nsIInterfaceRequestor) ||
		        aIID.equals(Components.interfaces.nsIChannelEventSink) || 
		        aIID.equals(Components.interfaces.nsIProgressEventSink) ||
		        aIID.equals(Components.interfaces.nsIHttpEventSink) ||
		        aIID.equals(Components.interfaces.nsIStreamListener))
		      return this;

		    throw Components.results.NS_NOINTERFACE;
		}
	};

})();

