var mainWindow = window.opener;
var D = mainWindow.diigo;

var editFilter = window.arguments?window.arguments[0]:null;
var insertPos = window.arguments?window.arguments[1]:null;

var currentTab=0;
var itemCount=20;

var gAutoCompleteTags = [].slice.call(D.env.myTags, 0);

var gjFilterType;
function onload() {
	gjFilterType = $('#radiogroup-filterType');
	gjFilterType.bind('select', function() {
		$('#deck-details')[0].selectedIndex = this.selectedIndex;
	});
	
	OnUpdateList();
	
	if(editFilter){
		switch(editFilter.type){
		case D.QAF.TYPE_TAG:
			gjFilterType[0].selectedIndex=0;
			$('#deck-details')[0].selectedIndex=0;
			$('#txt-tags').val(editFilter.name);
			if(editFilter.criteria.unread == true){
				$('#tag-unread').attr({checked:true});
			}else{
				$('#tag-unread').removeAttr("checked");
			}
			break;
		case D.QAF.TYPE_LIST:
			gjFilterType[0].selectedIndex=1;
			$('#deck-details')[0].selectedIndex=1;
			var item = diigoUtil.array.find($('#select-lists menupopup')[0].childNodes, function(s) {
				return s.value == editFilter.criteria.listId;
			});
			j.parent()[0].selectedItem=item;
			break;
		case D.QAF.TYPE_RECENT:
			gjFilterType[0].selectedIndex=2;
			$('#deck-details')[0].selectedIndex=2;
			break;
		case D.QAF.TYPE_UNREAD:
			gjFilterType[0].selectedIndex=3;
			$('#deck-details')[0].selectedIndex=3;
			break;
		}
	}

}

function OnUpdateList(){
	//lists
	var j = $('#select-lists menupopup');
	j.empty()
	.append(D.env.outliners.map(function(li) {
		return diigoUtil.dom.buildOne('menuitem', {
			'label': li.title,
			value: li.id 
		});
	}))
	.append(document.createElement('menuseparator'))
	.append(D.env.myList.map(function(li) {
		return diigoUtil.dom.buildOne('menuitem', {
			'label': li.title,
			value: li.id 
		});
	}))
	;
	//--------------------
	//.append(document.createElement('menuseparator'));
	//Create a List
	//.append(diigoUtil.dom.buildOne('menuitem', {
	//	'label': 'Create a List...',
	//	value: -1,
	//	'onclick': 'D.utils.firefox.openTab(D.urls.getCreateListURL()); var p = this.parentNode.parentNode; setTimeout(function() {p.selectedIndex = 0;}, 200);'
		//'onclick': 'D.handle("OnCreateList", event, OnUpdateList);var p = this.parentNode.parentNode; setTimeout(function() {p.selectedIndex = 0;}, 200);'
	//}));
	
	j.parent()[0].selectedIndex = 0;
	
}

function OnclickHelp(event){
	D.handle('openMenuItemUrl', event, 'filterHelp')
	mainWindow.focus();
}

function EditTag() {
	D.utils.firefox.openTab(D.urls.getEditTagsURL()); 
	mainWindow.focus();
}

/**
 * called by the autocomplete XBL
 * copied from addBookmark.js
 */
function getSuggestedTags(input) {
	var tags = D.parseTags(input);
	var lastTag = tags[tags.length - 1];
	if (!lastTag) return [];
	
	lastTag = lastTag.toLowerCase();
	return diigoUtil.array.unique(
			   gAutoCompleteTags
			   .filter(function(t) {return t.toLowerCase().indexOf(lastTag) == 0;})
		   ).map(function(t) {return {tag: t}});
}

function doOK() {
	if(currentTab==0){
		var type = gjFilterType[0].selectedItem.value, result,newFilter={
				type: D.QAF.TYPE_TAG,
				name: "init",
				bmcount: itemCount,
				criteria: {}
			};
		if (type == 'tag') {
			var szTags=$('#txt-tags').val();
			var tags = D.parseTags(szTags, true);
			if (tags.length == 0) {
				alert("Please input tag(s)!");
				return false;
			}
			if(editFilter){
				newFilter.type=D.QAF.TYPE_TAG;
				newFilter.name=szTags;
				newFilter.criteria={tags: tags,unread: $('#tag-unread').is(':checked')};
			}else
				result = D.QAF.addTagFilter(tags,$('#tag-unread').is(':checked'),insertPos,itemCount);
		} else if (type == 'list') {
			var ele = $('#select-lists')[0], listId = ele.value, listName = ele.selectedItem.label;
			if (listId <= 0) {
				alert('Please select a list!');
				return false;
			}
			if(editFilter){
				newFilter.type=D.QAF.TYPE_LIST;
				newFilter.name=listName;
				newFilter.criteria={listId: listId};
			}else
				result = D.QAF.addListFilter(listId, listName,insertPos,itemCount);
		} else if (type == 'unread') {
			if(editFilter){
				newFilter.type=D.QAF.TYPE_UNREAD;
				newFilter.name="Unread";
				newFilter.criteria={};
			}else
				result = D.QAF.addUnreadFilter(insertPos,itemCount);
		} else if (type == 'recent') {
			if(editFilter){
				newFilter.type=D.QAF.TYPE_RECENT;
				newFilter.name="Recent";
				newFilter.criteria={};
			}else
				result = D.QAF.addRecentFilter(insertPos,itemCount);
		}
		if(editFilter){
			result = D.QAF.compareFilter(newFilter,editFilter);
			if(result) return true;
			result = D.QAF.isAlreadyExist(newFilter);
			if(result){
				editFilter.type=newFilter.type;
				editFilter.name=newFilter.name;
				editFilter.criteria=newFilter.criteria;
				editFilter.bmcount=newFilter.bmcount;
				D.WebAPI.delFilter(editFilter.id);
				D.QAF.refreshUI(editFilter);
				D.QAF.loadBookmarksForFilter(editFilter);
				D.QAF._addFilter(editFilter);
			}
		}
		if (result === false) {
			diigoUtil.firefox.promptService().alert(window, 'Quick Access Filter', 'You already have this filter.');
			return false;
		}
		return true;
	}else{
		var lists=[];
		var len=__listbox.getRowCount()
		for (i = 0; i < len; i++) {
			item=__listbox.getItemAtIndex(i);
			if(item.checked){
				var list=tagsFilters[item.label];
				lists.push(list);
			}
		}
		if(lists.length>0){
			D.QAF._importFilter(lists);	
		}
		
		return true;
	}
}
function doCancel() {return true;}



//-------------import-----------------------------------

var __BMDS;
if (!D.ff3up) {
	__BMDS=__RDFS.GetDataSource("rdf:bookmarks"); 
}
var __listbox;

var tagsFilters={};
var bmList=[];

var folders=new Array();
var folderIndex=0;

function __Node(){
}
__Node.prototype.element = null;
__Node.prototype.childNodes = null;
__Node.prototype.offset = 0;
__Node.prototype.tags = "";


function getFilterNew(n){
	if(n==""){return null;}
	filter=tagsFilters[n];
	if(typeof filter=="undefined"){
		filter={title:n,bms:[]};
		tagsFilters[n]=filter;
	}
	return filter;
}

function __InitPopulate(){
	folders=null;
	folders=new Array();
	folderIndex=0;
	var root=new __Node();
	root.element=__BMROOT;
	root.bookmarkToolbar=false;
	folders.push(root);
}

function __PopulateBookmarks(toolbarOnly){
	if (D.ff3up) 
	  	return __PopulateBookmarks_ff3(toolbarOnly);
	else{
	  	__InitPopulate();
	  	__PerPopulateBookmark(toolbarOnly);
	} 
}

function __PopulateBookmarks_ff3(toolbarOnly){
	D.LocalBookmarks.readBookmarks(getFilterNew,toolbarOnly);
		
	for (n in tagsFilters) {
		var bm = tagsFilters[n];
		ui_one(bm);
	}
}

function ui_one(bm) {
  
    var listitem = document.createElement('listitem');
    listitem.setAttribute('label', bm.title);
    listitem.setAttribute('class', "listitem-iconic");
    listitem.setAttribute('image', "chrome://diigotb/skin/folder.gif");
    listitem.setAttribute('type', "checkbox");
    listitem.setAttribute('checked', true);
   
    __listbox.appendChild(listitem);
}

function __PerPopulateBookmark(toolbarOnly) {
	var node=folders[folderIndex++];
	__PopulateBookmarkFromNode(node,toolbarOnly);
	if(folderIndex<folders.length){
		setTimeout(function(){
			__PerPopulateBookmark(toolbarOnly);
		},10);
	}
}

var marks={};

function __PopulateBookmarkFromNode(node,toolbarOnly) {
	
	if(!node.childNodes){
		node.childNodes= __GetBookmarkContainer(node.element).GetElements();
	}
	marks={};
	for (var i = node.offset; node.childNodes.hasMoreElements(); i++) {
		var element = node.childNodes.getNext().QueryInterface(Components.interfaces.nsIRDFResource); 
		var target = __BMDS.GetTarget(element, __BM_NAME, true);           
		if(target) {
			var name = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			var targetType = __BMDS.GetTarget(element, __BM_TYPE, true);
			var type = targetType.QueryInterface(Components.interfaces.nsIRDFResource).Value.split("#")[1]; 
			if(type == "Bookmark"&&node.bookmarksubToolbar) {
				var urlObj = __BMDS.GetTarget(element, __BM_URL, true);           
				var url = urlObj.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
				url=DiigoAdjustor.adjustUrl(url);
				var urlid=MD5(url);
				if(marks[urlid]){
					continue;
				}else{ 
					marks[urlid]=true;
				}
				var tagValue=__BMDS.GetTarget(element,__BM_TAG,true);
				if(tagValue){
					tagValue=tagValue.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
				}
				
				var desValue=__BMDS.GetTarget(element,__BM_DESCRIPTION,true);
				
				var bm={
						title:name,
						url:url,
						tags:D.parseTags(tagValue, true),
						mode:D.PRIVACY_MODE_PRIVATE,
						description:desValue
					};

				tagsFilters[node.folderName].bms.push(bm);
				
			}else if(type == "Folder") {
				var n=new __Node();
				n.element=element;
				name=name.trim();
				if(name.length>0)
				{
					n.bookmarkToolbar=false;
					if(name.search(/Bookmarks Toolbar Folder/i)>=0)
					{
						n.bookmarkToolbar=true;
						n.bookmarksubToolbar=false;
					}
					name=name.replace('Bookmarks Toolbar Folder','Links');
					if(node.bookmarkToolbar){
						n.folderName=name;
						ui_one(getFilterNew(name));
						folders.push(n);
					}
					n.bookmarksubToolbar=node.bookmarkToolbar||node.bookmarksubToolbar;
				}
			}
		}
	}
}

function onSelectcount(id){
	for(var i=10;i<=50;i+=10){
		$('#count-Select-'+i).removeClass('selected');
	}
	$('#count-Select-'+id).addClass('selected');
	itemCount=id;
}

function importAllselect(){
	if(__listbox.getRowCount()>0){
		$(__listbox).children().attr({checked:true});
	}	
	$('#filter-Select-None').removeClass('selected');
	$('#filter-Select-All').addClass('selected');}

function importNoneselect(){
	if(__listbox.getRowCount()>0){
		$(__listbox).children().attr({checked:false});
	}
	$('#filter-Select-All').removeClass('selected');
	$('#filter-Select-None').addClass('selected');
}

function OnLoadBookmarks(){
	currentTab=1;
	__listbox=document.getElementById('diigo-bm-folder');
	if(__listbox.getRowCount()<=0){
	    setTimeout("__PopulateBookmarks(true);",100);
	}
}
